# -*- coding: utf-8 -*

#!/usr/bin/env python
#

import matplotlib
matplotlib.use('Template')
import matplotlib.pyplot as plt
import matplotlib.colors as clr
import matplotlib.font_manager as fm
import matplotlib.gridspec as grid
from matplotlib.patches import Rectangle
from matplotlib.collections import LineCollection
from matplotlib.patches import Polygon
from matplotlib.collections import PatchCollection
from matplotlib.patches import PathPatch
from matplotlib.colors import LightSource
import matplotlib as mpl
import pandas as pd
import numpy as np
import datetime as dt
import locale
import scipy as sp
from scipy import stats as st
import glob as gb
from netCDF4 import Dataset
from osgeo import gdal, osr
from osgeo.gdalconst import *                                       # shell utility module to work with os
import os, sys, time
from matplotlib.mlab import griddata
from mpl_toolkits.axes_grid1 import host_subplot
import mpl_toolkits.axisartist as AA
from mpl_toolkits.axes_grid1 import make_axes_locatable
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from mpl_toolkits.mplot3d import axes3d
from matplotlib.offsetbox import OffsetImage, AnnotationBbox
from dateutil.relativedelta import relativedelta
import MySQLdb
import psycopg2
import pickle
from windrose import WindroseAxes
#Reportlab
from reportlab.lib import colors
from reportlab.lib.pagesizes import letter, landscape, inch
from reportlab.lib.enums import TA_JUSTIFY, TA_LEFT
from reportlab.platypus import Image, Paragraph, SimpleDocTemplate, Table, TableStyle
from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
from reportlab.pdfgen import canvas
from reportlab.pdfbase import pdfmetrics
from reportlab.pdfbase.ttfonts import TTFont
from StringIO import StringIO
import scipy.ndimage
from reportlab.lib.enums import TA_JUSTIFY
from pyPdf import PdfFileWriter, PdfFileReader
from PDFImageSIATA import PdfImageSIATA
from pyPdf import PdfFileWriter, PdfFileReader
#import plotly.plotly as py
import plotly.graph_objs as go
import copy
import sys
import Air
sys.path.append('/home/calidadaire/ModuloAire/') #Esto es temporal
sys.path.append('/home/calidadaire/JupyterNotebooks/maasalazargo/P/ruidoNew/') #Esto es temporal

locale.setlocale(locale.LC_TIME, ('es_co','utf-8'))

reload (sys)
sys.setdefaultencoding('utf8')

prop = fm.FontProperties(fname='/home/calidadaire/ModuloAire/Tools/AvenirLTStd-Heavy.ttf',)
prop_1 = fm.FontProperties(fname='/home/calidadaire/ModuloAire/Tools/AvenirLTStd-Book.ttf',)
prop_2 = fm.FontProperties(fname='/home/calidadaire/ModuloAire/Tools/AvenirLTStd-Black.ttf',)
from ruido import ruido

class Ruido():

	## Class variable
	# Se puede acceder a ella mediante self.EstR
	EstR = pd.read_csv('/home/calidadaire/ModuloAire/Tools/EstacionesRuido.txt',index_col=0).sort_values(by='Latitud',ascending=False)

	def __init__(self,Variable=None,Estaciones=None,Fechai=None, Fechaf=None,Freq=5):
		self.idx               = pd.IndexSlice
		#self.freq = Freq
		self.Fechai      = (dt.datetime.now()-relativedelta(months=1)).strftime('%Y-%m-')+'01 00:00' if (Fechaf == None) else Fechai
		self.Fechaf      = (pd.to_datetime(self.Fechai) + relativedelta(months=1)-dt.timedelta(minutes=1)).strftime('%Y-%m-%d %H:%M') if (Fechaf == None) else Fechaf

		#Air.__init__(self,Fechai=self.Fechai,Fechaf=self.Fechaf)

		self.nombre_meteorologicas = ['P_SSR','PLiquida_SSR','TAire10_SSR','RGlobal_SSR','HAire10_SSR','VViento_SSR','DViento_SSR']
		#self.codigo_meteorologicas = [ 3,  6, 11, 12, 25, 28, 31, 37, 38, 40, 41, 44, 48]
		self.descrip_sector={
    'A':'Hospitales, bibliotecas, guarderias, sanatorios, hogares geriátricos.',
    'B':'Universidades,  colegios,  escuelas,  centros de estudio e investigación',
    'C1':'Zonas   con   usos   permitidos   industriales, como industrias en general, zonas portuarias, parques industriales, zonas francas.',
    'C2':'Zonas   con   usos   permitidos   comerciales, como centros comerciales, almacenes, locales  o  instalaciones  de  tipo  comercial, talleres  de  mecánica  automotriz  e  industrial, centros  deportivos  y  recreativos,  gimnasios, restaurantes,   bares,   tabernas,   discotecas, bingos, casinos.',
    'C3':'Zonas con usos institucionales.',
    'C4':'Zonas  con  otros  usos  relacionados,  como parques   mecánicos   al   aire   libre,   áreas destinadas  a  espectáculos  públicos  al  aire libre, vías troncales, autopistas, vías arterias, vías principales.',
    'D':'Residencial suburbana. Rural   habitada   destinada   a   explotación agropecuaria. Zonas   de   Recreación   y   descanso,   como parques naturales y reservas naturales.'
}
		self.norma_sector = {'A':[55,45],'B':[65,50],'C1':[75,70],'C2':[70,55],'C3':[65,50],'C4':[80,70],'D':[55,45]}
		self.norma_ruido={}
		for est in self.EstR.loc[:,'Nombre'].values: self.norma_ruido[est]=[self.EstR.loc[self.EstR.Nombre==est,'Sector'].values[0]]+self.norma_sector[self.EstR.loc[self.EstR.Nombre==est,'Sector'].values[0]]
		#self.norma_ruido = {'GIR-BOTJ': ['C', 70, 55], 'GIR-SOSN': ['B', 65, 50], 'BEL-ALCA': ['C', 70, 55], 'MED-PLMA': ['C', 80, 70], 'MED-ITMR': ['C', 80, 70],'MED-PJIR': ['B', 65, 50], 'MED-PJIC': ['B', 65, 50], 'ITA-CODI': ['C', 70, 55], 'ITA-SAMA': ['C', 70, 55] ,'SAB-SEMS': ['C', 70, 55], 'MED-ITMR': ['C', 80, 70], 'MED-SIAT': ['C', 70, 55],'MED-UNFM':['C',80,70], 'CEN-TRAF': ['C', 70, 55], 'MED-ZOOL':['C', 65, 50],'ITA-ACUA': ['C', 70, 55]}

		self.label       = {'Ruido':ur'Nivel de Presión Sonora $dB(A)$'}

		self.labelx       = {'Ruido':ur'Nivel de Presión Sonora $dB(A)$'}

		self.nombre_indicadores = ['CS','NRT','NExpo','NCR','DiffDN']

		self.dias_es 		= {'1':'L','2':'M','3':'Mi','4':'J','5':'V','6':'S','0':'D','7':'D'}
		self.mes_es 		= {1:'Enero',2:'Febrero',3:'Marzo',4:'Abril',5:'Mayo',6:'Junio',7:'Julio',8:'Agosto',9:'Septiembre',10:'Octubre',11:'Noviembre',12:'Diciembre'}
		self.unidadesMeteo	= {'P_SSR':'hPa','PLiquida_SSR':'mm','TAire10_SSR':'C','RGlobal_SSR':'W/m2','HAire10_SSR':'%','VViento_SSR':'m/s','DViento_SSR':'Deg'}

		self.Est			= pd.read_csv('/home/calidadaire/ModuloAire/Tools/Estaciones.txt',index_col=0).sort_values(by='Latitud',ascending=False)
		self.Est.loc[self.Est[self.Est['Vaisala']==1].index,'Nombre']=self.Est[self.Est['Vaisala']==1]['Nombre'].astype(int)

		self.EstV			= pd.read_csv('/home/calidadaire/ModuloAire/Tools/Estaciones_Vaisala.txt',index_col=0).sort_values(by='Latitud',ascending=False)
		self.EstV.loc[self.EstV[self.EstV['Vaisala']==1].index,'Nombre']=self.EstV[self.EstV['Vaisala']==1]['Nombre'].astype(int)

		self.var			= Variable
		self.Contaminante	= None
		self.resol 			= 'D'
		self.run			= False
		self.path			= os.getcwd()


		self.frec_ruido = {'20 Hz':'dato_20', '25 Hz':'dato_25', '32 Hz':'dato_32', '40 Hz':'dato_40', '50 Hz':'dato_50', '63 Hz':'dato_63', '80 Hz':'dato_80', '100 Hz':'dato_100', '125 Hz':'dato_125', '160 Hz':'dato_160', '200 Hz':'dato_200', '250 Hz':'dato_250', '315 Hz':'dato_315', '400 Hz':'dato_400','500 Hz':'dato_500', '630 Hz':'dato_630', '800 Hz':'dato_800', '1k Hz':'dato_1000', '1k25 Hz':'dato_1025', '1k6 Hz':'dato_1600', '2k Hz':'dato_2000', '2k5 Hz':'dato_2500', '3k15 Hz':'dato_3150', '4k Hz':'dato_4000', '5k Hz':'dato_5000', '6k3 Hz':'dato_6300', '8k Hz':'dato_8000', '10k Hz':'dato_10000', '12k5 Hz':'dato_12500', '16k Hz':'dato_16000', '20k Hz':'dato_20000' }

		self.frecuencias = ['20 Hz', '25 Hz', '32 Hz', '40 Hz', '50 Hz', '63 Hz', '80 Hz', '100 Hz', '125 Hz', '160 Hz', '200 Hz', '250 Hz', '315 Hz', '400 Hz','500 Hz', '630 Hz', '800 Hz', '1k Hz', '1k25 Hz', '1k6 Hz', '2k Hz', '2k5 Hz', '3k15 Hz', '4k Hz', '5k Hz', '6k3 Hz', '8k Hz', '10k Hz', '12k5 Hz', '16k Hz', '20k Hz']

		self.AjusteZ = {'20 Hz':50.5, '25 Hz':44.7, '31,5 Hz':39.4, '40 Hz':34.6, '50 Hz':30.2, '63 Hz':26.2, '80 Hz':22.5, '100 Hz':19.1, '125 Hz':16.1, '160 Hz':13.4, '200 Hz':10.9, '250 Hz':8.6, '315 Hz':6.6, '400 Hz':4.8, '500 Hz':3.2, '630 Hz':1.9, '800 Hz':0.8, '1k Hz':0.0, '1,25k Hz':-0.6, '1,6k Hz':-1.0, '2k Hz':-1.2, '2,5k Hz':-1.3, '3,15k Hz':-1.2, '4k Hz':-1.0, '5k Hz':-0.5, '6,3k Hz':0.1, '8k Hz':1.1, '10k Hz':2.5}

#		self.Aire = Air.Air()
		self.Aire = Air.Air(Fechai=self.Fechai,Fechaf=self.Fechaf)
		self.ruido= ruido()

	def Aire_db(self,*args,**kwargs): 

		print '-------------------------------------------'
		print 'Lectura Datos Estaciones Aire_db Ruido'
		print '-------------------------------------------'
		print '\n'

		#self.Variable		= kwargs.get('Variable',None)
		self.Estaciones		= kwargs.get('Estaciones',None)
		self.Flag		= kwargs.get('Flags',False)
		self.Meteorologicas	= kwargs.get('Meteorologicas',False)
		self.Ruido		= kwargs.get('Ruido',False)
		self.thiess_est         = kwargs.get('thiess_est',[254,198,1019])
		MeteoRuido		=kwargs.get('MeteoRuido',False)
		#if (type(self.var) ==type(None)) & (type(self.Variable)==type(None)):
		#	print 'Definir Variable: self.var="X"'
		#elif self.Variable!=None:
		#	self.var1= self.Variable
		#else:
		#	pass

		#print self.var1
		#print '\n'

		self.Estaciones=self.EstR.index[(self.EstR['Ruido']==1)&(self.EstR.index!=76)].values if (self.Estaciones == None) else self.Estaciones
		self.Estacion = str(list(self.Estaciones)).strip('[]')	

		if MeteoRuido:
			#self.EstacionesP    	= {'GIR-BOTJ':31,'ITA-SAMA':395,'SAB-SEMS':146,'ITA-ACUA':36} ##'MED-PLMA':45 'ITA-CODI':36
			#self.EstacionesThiess = {'MED-PJIR':198 ,'MED-PJIC':198, 'MED-SIAT':1019, 'MED-ZOOL':198} #'MED-PJIC':198
			#self.EstacionesVaisala= {'CEN-TRAF':202,'ITA-ACUA':206}
			### Dict de nombres de estaciones de Ruido con el code de su subsi
			self.EstacionesP = dict(zip(self.EstR.loc[self.EstR.Pluviometro>0]['Nombre'].values,self.EstR.loc[self.EstR.Pluviometro>0]['Pluviometro'].values))
                        self.EstacionesThiess = dict(zip(self.EstR.loc[self.EstR.Thiess>0]['Nombre'].values,self.EstR.loc[self.EstR.Thiess>0]['Thiess'].values))
			self.EstacionesVaisala= dict(zip(self.EstR.loc[self.EstR.Vaisala>0]['Nombre'].values,self.EstR.loc[self.EstR.Vaisala>0]['Vaisala'].values))

			self.Pluvio 		= self.Aire.Aire_db(Variable='PPT',Pluviometro=True,Estaciones=list(set(self.EstacionesP.values())))
			self.Pluvio 		= self.Pluvio.stack(0).unstack(1).resample('h').sum()
			self.MeteoThiess        = self.Aire.Aire_db(Estaciones=list(set(self.EstacionesThiess.values())),thiess=True,varthiess=['vv','dv'])
			self.MeteoThiess        = self.MeteoThiess.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))
			self.VThiess            = self.MeteoThiess['vv']
			self.DVThiess            = self.MeteoThiess['dv']
			self.MeteoThiess        = self.Aire.Aire_db(Estaciones=list(set(self.EstacionesThiess.values())),thiess=True,varthiess=['p'])
			self.MeteoThiess        = self.MeteoThiess.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))
			self.PThiess            = self.MeteoThiess['p']

			self.MeteoVaisala	= self.Aire.Aire_db(varvaisala=['sm','dm'],Vaisala=True,Estaciones=list(set(self.EstacionesVaisala.values())))
			self.MeteoVaisala1	= self.Aire.Aire_db(varvaisala=['rc'],Vaisala=True,Estaciones=list(set(self.EstacionesVaisala.values())))
			self.MeteoVaisala       = self.MeteoVaisala.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))
			self.MeteoVaisala1       = self.MeteoVaisala1.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))

			for est in np.unique(self.EstacionesVaisala.values()):
				self.DVThiess[est]	= self.MeteoVaisala['dm'][est]
				self.VThiess[est]	= self.MeteoVaisala['sm'][est]/10.
				self.PThiess[est]	= self.MeteoVaisala1['rc'][est]/1000.

			self.EstacionesThiess.update(self.EstacionesVaisala)
			self.DThiess=pd.DataFrame(columns=np.unique(self.EstacionesThiess.values()),index=pd.date_range(self.Fechai,self.Fechaf,freq='T'))
			for est in np.unique(self.EstacionesThiess.values()):
				U=self.VThiess[est]*np.cos(self.DVThiess[est]*np.pi/180.)
				V=self.VThiess[est]*np.sin(self.DVThiess[est]*np.pi/180.)
				U=U.resample('H').mean()
				V=V.resample('H').mean()
				self.DThiess[est]=(np.arctan2(V,U)*180./np.pi)%360 

			self.PThiess            = self.PThiess.resample('h').sum() 
			self.VThiess            = self.VThiess.resample('h').mean()
			self.Aire.Read_db(MeteoRuido=True)
			self.Met=self.Aire.Meteo

			self.Met['PLiquida_SSR'].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			self.PThiess=self.PThiess.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			self.Pluvio=self.Pluvio.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			self.Met['VViento_SSR']=self.Met['VViento_SSR'].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			#self.VThiess.rename(columns={198:"MED-PJIC",254:"GIR-SOSN",1019:'MED-SIAT',202:'CEN-TRAF'},inplace=True)

			self.VThiess=self.VThiess.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			for est in self.EstacionesThiess.keys():
				try:
					MeteoSub=pd.concat([self.DThiess[self.EstacionesThiess[est]],self.Met['DViento_SSR'][est]],axis=1)
					MeteoSub.columns=['t','bd']
					self.Met['DViento_SSR'][est]=MeteoSub['bd'].add(MeteoSub['t']*(np.logical_not(MeteoSub['bd']>0)), fill_value=0)
				except:
					MeteoSub=self.DThiess[[self.EstacionesThiess[est]]]
                    			MeteoSub.columns=['t']
                    			self.Met['DViento_SSR'][est]=MeteoSub['t']

			for est in self.EstacionesThiess.keys():
				try:
					MeteoSub=pd.concat([self.VThiess[self.EstacionesThiess[est]],self.Met['VViento_SSR'][est]],axis=1)
					MeteoSub.columns=['t','bd']
					self.Met['VViento_SSR'][est]=MeteoSub['bd'].add(MeteoSub['t']*(np.logical_not(MeteoSub['bd']>0)), fill_value=0)
				except:
				        MeteoSub=self.VThiess[[self.EstacionesThiess[est]]]
                    			MeteoSub.columns=['t']
                    			self.Met['VViento_SSR'][est]=MeteoSub['t']

			for est in self.EstacionesP.keys():
				try:
					MeteoSub=pd.concat([self.Met['PLiquida_SSR'][est],self.Pluvio[str(self.EstacionesP[est])].mean(axis=1).resample('H').sum()],axis=1)
					MeteoSub.columns=['t','bd']
				## Pluvio ITA-CODI mala
					self.Met['PLiquida_SSR'][est]=MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0) if est!='ITA-CODI' else np.logical_not(MeteoSub['t']>=0)), fill_value=0)
				except:
					MeteoSub=self.Pluvio[[str(self.EstacionesP[est])]].mean(axis=1).resample('H').sum()
					MeteoSub=pd.DataFrame(MeteoSub)
                    			MeteoSub.columns=['bd']
                    			self.Met['PLiquida_SSR'][est]=MeteoSub['bd']
#			for est in self.EstacionesThiess.keys():
#				if est=='MED-PJIR': # or est=='MED-PJIR': Se cambia MED-PJIC por MET-PJIC
#					concatena=self.MeteoThiess['p'][self.EstacionesThiess[est]].resample('H').sum()
#				else:
#					concatena=self.PThiess[self.EstacionesThiess[est]]
#				MeteoSub=pd.concat([self.Met['PLiquida_SSR'][est],concatena],axis=1)
#				MeteoSub.columns=['t','bd']
#				self.Met['PLiquida_SSR'][est]=MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0)), fill_value=0)


		return self.Met if MeteoRuido else None

        def Informe_Ruido(self,*args,**kwargs):

                #os.chdir('/home/jhernandezv/RedAire/Informe_Mensual/')
                self.Correo             = kwargs.get('Correo',False)
                self.read               = kwargs.get('read',True)
                self.Figuras    = kwargs.get('Figuras',True)
                self.Latex              = kwargs.get('Latex',True)
                self.Datos              = kwargs.get('Datos',True)
                self.database   = kwargs.get('database',True)
                self.Texto_Ruido= kwargs.get('Texto_Ruido','')
                self.Save_csv   = kwargs.get('Save_csv',True)

                self.mes_ruido          = self.Fechai[:7]

                if self.database:

			# Crear self.L (dataframe con frecuenciaas)
			self.Read_Noise()

			# Crear self.LR con LRAeqD, LRAeqN, LRAeqDN y LRAeqH
			
			#LRs={}
			#LRs=self.Aire.Aire_db(LRAdiario=True,Variable=['LRAeqD','LRAeqN','LRAeqDN'])
			#self.LRAeqH=self.Aire.Aire_db(LRAhorario=True)
			#self.LRAeqD  = LRs['LRAeqD']
			#self.LRAeqN  = LRs['LRAeqN']
			#self.LRAeqDN = LRs['LRAeqDN']
			#self.LRAeqH  = LRs['LRAeqH]

			## Reemplazamos por las nuevas funciones para consulta de datos

			self.LRAeqH  = self.ruido.consulta(variable='LRAeq',tipo='H',fechai=self.ruido.fechai,fechaf=self.ruido.fechaf)['LRAeqH']
			self.LRAeqD  = self.ruido.consulta(variable='LRAeq',tipo='D',fechai=self.ruido.fechai,fechaf=self.ruido.fechaf)['LRAeqD']
			self.LRAeqN  = self.ruido.consulta(variable='LRAeq',tipo='N',fechai=self.ruido.fechai,fechaf=self.ruido.fechaf)['LRAeqN']
			self.LRAeqDN = self.ruido.consulta(variable='LRAeq',tipo='DN',fechai=self.ruido.fechai,fechaf=self.ruido.fechaf)['LRAeqDN']

			#LRs['LRAeqH']=self.LRAeqH
			self.IndexD=self.Indicadores(Periodo='D')  ## Hace self.Index
			self.IndexN=self.Indicadores(Periodo='N')  ## Hace self.Index
			
# 			self.IndexD,self.IndexN = self.ruido.indicadores_informe()
			self.LR = pd.concat({'LRAeqH':self.LRAeqH,'LRAeqD':self.LRAeqD,'LRAeqN':self.LRAeqN,'LRAeqDN':self.LRAeqDN},axis=1)
			self.LR.to_csv('/home/calidadaire/ModuloRuido/Informe/Datos/LR.csv')
                else:
                        self.Read_Noise_txt()
                        #self.L = self.L[self.mes_ruido]
                        self.L = self.L[self.Fechai:self.Fechaf] # Para que corra toda la historia y no solo el ultimo mes
                        #self.L = self.L[['GIR-BOTJ',  'MED-PJIR', 'SAB-SEMS','ITA-SAMA', 'MED-SIAT', 'CEN-TRAF', 'MED-ZOOL','ITA-ACUA']] #,'BEL-ALCA', 'MED-UNFM', 'MED-PLMA', 'GIR-SOSN', 'ITA-CODI', 'MED-PJIC'
			### Debido a que los dropna me están botando todos los datos de las estaciones Pulsar
			## por no tener datos en las últimas frecuencias, se hace el dropna con las columns desde antes
			## y de esta manera vivir en paz
			self.L = self.L.dropna(axis=1,how='all') ## Ya se verificó que funcione con el multiindexado
                        # Filtro
                        print 'Filtrando datos que no contienen el 50% por hora o presenta datos faltantes continuos mayores a 15 minutos'

                        self.filtro1 = self.L.resample('H').count()/60.<.5 

                        for est in self.EstR[self.EstR['Ruido']==1]['Nombre'].values: 
                                print '\n=====================\n Estación %s \n=====================\n' %est

                                self.index1 = self.L[est].resample('H').mean().index 
                                self.index1 = self.index1.append(self.index1 + dt.timedelta(minutes=59) ) 
                                self.index1 = self.index1.difference( self.L[est].dropna().index.intersection(self.index1) )
                                self.filtro2 = pd.DataFrame(np.ones((self.index1.size,self.L[est].columns.size))*-1,index=self.index1,columns=self.L[est].columns.values).sort_index()
                                self.filtro2 = pd.concat([self.L[est].dropna(),self.filtro2],).sort_index()

                                for date in self.filtro2.dropna().apply(lambda x: x[:-1][ (x.index[1:] - x.index[:-1]) > dt.timedelta(minutes=15) ] ).index.join ( self.filtro1[est][self.filtro1[est].values.any(1)].index, how='outer' ):
                                        self.L.loc[date.strftime('%Y-%m-%d %H'),est] = np.NaN

                        self.Ajuste_Tonalidades()
                        self.Filtro_Ruido(save_csv=self.Save_csv)
			#self.Indicadores()

                if self.Figuras:
                        os.system('rm -rf Informe/Figuras/')
                        os.system('mkdir Informe/Figuras/')
                        os.system('mkdir Informe/Figuras/Ruido/')


                        os.system('mkdir Informe/Figuras/PLiquida_SSR')
                        os.system('mkdir Informe/Figuras/Meteorologia')
			
			#Plots Meteorlogía
			#self.Aire.Meteo=self.Aire_db(MeteoRuido=True)  #Esperemos no cagarla
			self.Met = self.ruido.meteo_subsidiado()     #Tengo miedo
			self.Aire.Plot_Precipitacion(df=self.Met['PLiquida_SSR'])
			
			## Luego de modificar la función, damos de entrada el df
			
			#self.Aire.Plot_CD_HR_T_RG()
			self.Aire.Plot_CD_HR_T_RG(df=self.Met)
			
			#Viento
			#-Total
			self.Aire.Plot_WindRose_Map(S=self.Met['VViento_SSR'],D=self.Met['DViento_SSR'],textsave='_Total',Vaisala=False,spanish=True,add_Text='Total',path='CalidadAire/Figuras/Meteorologia/')
			#-Diurno
			self.Aire.Plot_WindRose_Map(S=self.Met['VViento_SSR'][(self.Met.index.hour >= 7) & (self.Met.index.hour < 21)],D=self.Met['DViento_SSR'][(self.Met.index.hour >= 7) & (self.Met.index.hour < 21)],textsave='_Diurno',Vaisala=False,spanish=True,add_Text='Diurno',path='CalidadAire/Figuras/Meteorologia/')
			#-Nocturno
			self.Aire.Plot_WindRose_Map(S=self.Met['VViento_SSR'][(self.Met.index.hour < 7) | (self.Met.index.hour >= 21)],D=self.Met['DViento_SSR'][(self.Met.index.hour < 7) | (self.Met.index.hour >= 21)],textsave='_Nocturno',Vaisala=False,spanish=True,add_Text='Nocturno',path='CalidadAire/Figuras/Meteorologia/')

			### Figuras de meteorología de CEN-TRAF
			
			self.Plot_CD(df=self.LRAeqH,Informe=True)

                        self.var='Ruido'

                        #estaciones = self.L.columns.levels[0].values[ np.unique(self.L.columns.labels[0].values())]
                        #df = self.LR.LRAeqDN[estaciones].resample('D').mean()
                        #self.Plot_ImshowDN(df=df)
                        #aaaa.aaaa

                        for est in self.L.columns.levels[0].values[ np.unique(self.L.columns.labels[0].values())]:
                        	#for est in self.L.keys():
                                self.df         = pd.concat({'LRAeqD':self.LRAeqD[est],'LRAeqN':self.LRAeqN[est]},axis=1)
                                self.Plot_Ruido_Norma(self.df,est,textsave='_%s' %(est))
                                #self.df        = self.LR.LRAeqDN[est].resample('D').mean()
                                #self.Plot_Ruido_DiurnoNocturno(self.df,est,textsave='_%s' %(est))
                        estaciones = self.L.columns.levels[0].values[ np.unique(self.L.columns.labels[0].values())]
                        #estaciones = self.L.keys()
                        df = self.LRAeqDN[estaciones]
                        self.Plot_ImshowDN(df=df)
			
                        self.Plot_Ruido_Semanal(save_csv=True)
			#aaa.aaa
                        self.Aire.var='Ruido'
                        self.Aire.Plot_Mapa3()
			
			for ind in self.nombre_indicadores[:-1]:
# 				self.Plot_ImshowDN(df=self.IndexD[ind],Indicador=ind,textsave='diurno')
# 				self.Plot_ImshowDN(df=self.IndexN[ind],Indicador=ind,textsave='nocturno')
# 			self.Plot_ImshowDN(df=self.IndexD['DiffDN'],Indicador='DiffDN')
#  Se corrige problema de redondeo
  				self.Plot_ImshowDN(df=np.round(self.IndexD[ind],decimals = 0),Indicador=ind,textsave='diurno')
				self.Plot_ImshowDN(df=np.round(self.IndexD[ind],decimals = 0),Indicador=ind,textsave='nocturno')
			self.Plot_ImshowDN(df=np.round(self.IndexD['DiffDN'],decimals = 0),Indicador='DiffDN')
			
			# Plots del LRAeq D y N en cuadritos, solicitado por el amva
			lraeqD = self.ruido.consulta(variable='LRAeq',tipo='D')['LRAeqD']
			lraeqN = self.ruido.consulta(variable='LRAeq',tipo='N')['LRAeqN']
			self.Plot_ImshowDN(df=lraeqD,textsave='diurno')
			self.Plot_ImshowDN(df=lraeqN,textsave='nocturno')

		if self.Latex:
			self.mes_ruido = self.mes_es[self.L.index[0].month]+self.L.index[0].strftime('%Y')
			os.system('rm -r Informe/Informe_Ruido_%s' %self.mes_ruido )
			os.system('mkdir Informe/Informe_Ruido_%s' %self.mes_ruido )


			print 'copy Plantilla/ y Descripcion_Red/'
			os.system('cp -r /home/calidadaire/ModuloAire/Tools/Plantilla/ /home/calidadaire/ModuloAire/Tools/Descripcion/ /home/calidadaire/ModuloRuido/Informe/Figuras/')

			print 'copy Tablas y Figuras'
			os.system('cp -r Informe/Datos/ Informe/Informe_Ruido_%s/' %self.mes_ruido)
			os.system('cp -r Informe/Figuras/ Informe/Informe_Ruido_%s/' %self.mes_ruido)

			#Cambio de path
			os.system('cp /home/calidadaire/ModuloRuido/Informe/InformeRuido.py /home/calidadaire/ModuloRuido/Informe/Informe_Ruido_%s/' %self.mes_ruido)
			#aaa.aaa
			os.chdir('Informe/Informe_Ruido_%s/' %self.mes_ruido)
			#os.system('cd Informe/Informe_Ruido_%s/' %self.mes_ruido)

			print 'ipython InformeRuido.py'
			os.system('ipython InformeRuido.py "%s"' %self.Texto_Ruido)
			print 'latex'

			#os.system('rm *.py')
			os.system('pdflatex InformeRuido.tex')
			os.system('bibtex InformeRuido')
			os.system('pdflatex InformeRuido.tex')
			os.system('pdflatex InformeRuido.tex')

			os.system('scp InformeRuido.pdf sjaramillo@siata.gov.co:/var/www/CalidadAire/Informes_Operacion/F-GAA-RA-76_Informe_Ruido_%s.pdf' %(self.mes_ruido))

			if self.Correo:
				#vamos a ver si copia
				consecutivo=23+(pd.to_datetime(self.Fechai)-pd.to_datetime('2018-06-01')).days/28
				os.system('scp InformeRuido.pdf sjaramillo@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/%s_F-GAA-RA-76_Informe_Ruido_%s.pdf' %(consecutivo,self.mes_ruido))
				#Hace el cuerpo del correo
				os.system('python /home/calidadaire/ModuloRuido/Correo/mailDo_Ruido.py')
				self.contador_informe_ruido = open('/home/calidadaire/ModuloRuido/contador_informe_ruido.txt','r+')
				self.contador_IR = int(self.contador_informe_ruido.read().replace('\n',''))
				#os.system('scp InformeRuido.pdf sjaramillo@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/%s_F-GAA-RA-212_Informe_Ruido_%s.pdf' %('0%d' %self.contador_IR if self.contador_IR <10 else '%d' %self.contador_IR,self.mes_ruido))
				np.savetxt('/home/calidadaire/ModuloRuido/contador_informe_ruido.txt',[self.contador_IR +1 ],fmt = '%d')
				self.contador_informe_ruido.close()

			os.chdir('/home/calidadaire/ModuloRuido/')
			self.path		= os.getcwd()
			self.path_U		= self.path+'/Correo'
			path_proc		= '/home/calidadaire/ModuloAire/Informe_Mensual/Procuraduria/Informes' #Para procuraduría

			# por aca
		 	os.system('scp /home/calidadaire/ModuloRuido/Informe/Datos/LR.csv nroldan@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/Datos_Finales/LR-%s.csv' %(self.mes_ruido))
			#os.system('rm Informe/Informe_Ruido_%s/*.py' %self.mes_ruido)
			os.system('zip -r Informe/Informe_Ruido_%s.zip Informe/Informe_Ruido_%s/' %(self.mes_ruido,self.mes_ruido))

			os.system('scp Informe/Informe_Ruido_%s.zip sjaramillo@siata.gov.co:/var/www/CalidadAire/Informes_Operacion/' %self.mes_ruido)

		if self.Datos:
			self.path		= os.getcwd()
			self.path_U			= self.path+'/Correo'
			os.system('rm -r Informe/Datos/*')
			for est in self.L.columns.levels[0].values[np.unique(self.L.columns.labels[0].values())]:
				self.L[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T')).fillna(-9999).to_csv('Informe/Datos/Ruido_%s_%s.csv' %(est,self.mes_ruido))

			os.system('zip -r RedRuido_%s.zip Informe/Datos/' %self.L.index[0].strftime('%Y-%m'))

			if self.Correo:  #Verificar esto 
				year_month=self.mes_es[int(self.Fechai[5:7])]+self.Fechai[:4]
				#proc= '%s/F-GAA-RA-203_InformeProcuraduria_%s.pdf %s/F-GAA-RA-203_InformeProcuraduria_%s_Anexos.pdf'%(path_proc,year_month,path_proc,year_month)
				os.system('scp -r %s/%s_InformeProcuraduria_%s sjaramillo@siata.gov.co:/var/www/Informes_Aire/'%(path_proc,consecutivo,year_month))
				##intento
				##os.system('scp %s/F-GAA-RA-203_InformeProcuraduria_%s.pdf sjaramillo@siata.gov.co:/var/www/Informes_Aire/%s_InformeProcuraduria_%s'%(path_proc,year_month,consecutivo,year_month))
				##os.system('scp %s/F-GAA-RA-203_InformeProcuraduria_%s_Anexos.pdf sjaramillo@siata.gov.co:/var/www/Informes_Aire/%s_InformeProcuraduria_%s'%(path_proc,year_month,consecutivo,year_month))
				os.system("python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Informe Mensual de Ruido Ambiental e Informe para Procuraduría' %s/mail.body.ruidomod.html %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.path_U,self.path+'/Informe',self.L.index[0].strftime('%Y-%m')))
				#os.system("python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Informe Mensual Ruido Ambiental e Informe de Procuraduría' %s/mail.body.ruidomod.html %s/Informe/Informe_Ruido_%s/InformeRuido.pdf %s %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.path_U,self.path,self.mes_ruido,proc,self.path,self.L.index[0].strftime('%Y-%m')))
				#os.system("python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Datos Ruido Ambiental %s' %s/mail.body.ruido_datos.html %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.L.index[0].strftime('%B de %Y'),self.path_U,self.path,self.L.index[0].strftime('%Y-%m')))
				print "python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Informe Mensual de Ruido Ambiental e Informe para Procuraduría' %s/mail.body.ruidomod.html %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.path_U,self.path,self.L.index[0].strftime('%Y-%m'))
				os.system('scp RedRuido_%s.zip sjaramillo@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/BD_Ruido/' %self.L.index[0].strftime('%Y-%m'))


	def Latex_Informe_mensual(self,*args,**kwargs):
		self.Texto_Ruido= kwargs.get('Texto_Ruido','')
		self.mes_ruido = self.mes_es[int(self.Fechai[5:7])]+self.Fechai[:4]

		#Cambio de path
		os.system('cp /home/calidadaire/ModuloRuido/Informe/InformeRuido.py /home/calidadaire/ModuloRuido/Informe/Informe_Ruido_%s/' %self.mes_ruido)
		#aaa.aaa
		os.system('cp Informe/InformeRuido.py  Informe/Informe_Ruido_%s' %self.mes_ruido)
		os.chdir('Informe/Informe_Ruido_%s/' %self.mes_ruido)

		print 'ipython InformeRuido.py'
		os.system('ipython InformeRuido.py "%s"' %self.Texto_Ruido)
		print 'latex'

		#os.system('rm *.py')
		os.system('pdflatex InformeRuido.tex')
		os.system('pdflatex InformeRuido.tex')

		os.system('scp InformeRuido.pdf sjaramillo@siata.gov.co:/var/www/CalidadAire/Informes_Operacion/F-GAA-RA-76_Informe_Ruido_%s.pdf' %(self.mes_ruido))



	def Correo_Informe_Mensual(self,*args,**kwargs):
		read             = kwargs.get('read',True)
		if read:
	                # Crear self.L (dataframe con frecuenciaas)
			self.Read_Noise()

			LRs={}
			LRs=self.Aire.Aire_db(LRAdiario=True,Variable=['LRAeqD','LRAeqN','LRAeqDN'])
			self.LRAeqH=self.Aire.Aire_db(LRAhorario=True)
			self.LRAeqD  = LRs['LRAeqD']
			self.LRAeqN  = LRs['LRAeqN']
			self.LRAeqDN = LRs['LRAeqDN']
			#self.LRAeqH  = LRs['LRAeqH']
			#LRs['LRAeqH']=self.LRAeqH
			self.LR = pd.concat({'LRAeqH':self.LRAeqH,'LRAeqD':self.LRAeqD,'LRAeqN':self.LRAeqN,'LRAeqDN':self.LRAeqDN},axis=1)
		self.mes_ruido = self.mes_es[int(self.Fechai[5:7])]+self.Fechai[:4]
		#vamos a ver si copia
		consecutivo=23+(pd.to_datetime(self.Fechai)-pd.to_datetime('2018-06-01')).days/28
		os.system('scp InformeRuido.pdf sjaramillo@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/%s_F-GAA-RA-76_Informe_Ruido_%s.pdf' %(consecutivo,self.mes_ruido))
		#Hace el cuerpo del correo
		os.system('python /home/calidadaire/ModuloRuido/Correo/mailDo_Ruido.py')


		os.chdir('/home/calidadaire/ModuloRuido/')
		self.path		= os.getcwd()
		self.path_U		= self.path+'/Correo'
		path_proc		= '/home/calidadaire/ModuloAire/Informe_Mensual/Procuraduria/Informes' #Para procuraduría
		'''
		os.system('rm Informe/Datos/*')

		for est in self.L.columns.levels[0].values[np.unique(self.L.columns.labels[0].values())]:
			self.L[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T')).fillna(-9999).to_csv('Informe/Datos/Ruido_%s_%s.csv' %(est,self.mes_ruido))

		os.system('zip -r RedRuido_%s.zip Informe/Datos/' %self.L.index[0].strftime('%Y-%m'))
		'''
		year_month=self.mes_es[int(self.Fechai[5:7])]+self.Fechai[:4]
		os.system('scp -r %s/%s_InformeProcuraduria_%s sjaramillo@siata.gov.co:/var/www/Informes_Aire/'%(path_proc,consecutivo,year_month))
		os.system("python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Informe Mensual de Ruido Ambiental e Informe para Procuraduría' %s/mail.body.ruidomod.html %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.path_U,self.path,self.L.index[0].strftime('%Y-%m')))
		print "python %s/enviarCorreoElectronicoInformacion.py %s/mail.destino.ruido.txt 'Informe Mensual de Ruido Ambiental e Informe para Procuraduría' %s/mail.body.ruidomod.html %s/RedRuido_%s.zip" %(self.path_U,self.path_U,self.path_U,self.path,self.L.index[0].strftime('%Y-%m'))
		os.system('scp RedRuido_%s.zip sjaramillo@siata.gov.co:/var/www/Informes_Aire/Informes_Ruido/BD_Ruido/' %self.L.index[0].strftime('%Y-%m'))


	def Read_Noise(self,*args,**kwargs):
		self.L = {}
		for est in self.EstR[self.EstR['Ruido']==1].index.values:
			print est
			try: self.L[self.EstR['Nombre'][self.EstR.index==est].values[0]] = self.Aire.Aire_db(Variable='Ruido',Estaciones=[est],Ruido=True)
			except: pass
		self.L          = pd.concat(self.L,axis=1)

	def Read_Noise_txt(self,*args,**kwargs):

		self.estacion		= kwargs.get('estacion','*')
		self.Ruido		= kwargs.get('Ruido',True)
		self.Meteorologicas	= kwargs.get('Meteorologia',True if dt.datetime.strptime(self.Fechai[0:10], "%Y-%m-%d") < dt.datetime(2018,12,01) else False)


		def poscol(x):
			poscol = []
			for i in range(2,x.columns.size):
			
				if (x.columns.values[i][-5:] !='_Ovld') & ((x.columns.values[i] != 'Hour') ^ (x.columns.values[i] != 'Date') ^ (x.columns.values[i] != 'Date_Hour') ^ (x.columns.values[i] != 'Elapsed_T_Time') ^ (x.columns.values[i][:7] != 'Unnamed') ) :poscol.append(i)
			return poscol

		self.L={}
		Nhist=-5 # Leer toda la historia: Nhist=1. Leer solo ultimos 10 archivos: Nhist=-10
		if self.Ruido:
			self.Estaciones = gb.glob('/home/calidadaire/ModuloRuido/DatosRuido/Ruido/%s' %(self.estacion))

			#if self.estacion in ['MED-PJIR','MED-SIAT','MED-UNFM']: self.Estaciones.append('/home/calidadaire/ModuloRuido/DatosRuido/Ruido/SAB-SEMS') # MED-UNFM, MED-PJIC

			for e in self.Estaciones:
				print e

				self.est        = e[-8:]
				self.files      = sorted(gb.glob('%s/*%s' %(e, '.txt' if self.est not in ['MED-PJIC','MED-SIAT','MED-UNFM'] else '')),key = os.path.getmtime) #MED-UNFM
				#self.files      = sorted(gb.glob('%s/*%s' %(e, '.txt' if self.est not in ['MED-PJIC','MED-UNFM','MED-ITMR','MED-SIAT'] else '')),key = os.path.getmtime)
				#self.files		= gb.glob('%s/*%s' %(e, '.txt' if self.est not in ['MED-PJIC','MED-UNFM','MED-ITMR','MED-SIAT'] else ''))
				self.files      =    self.files[Nhist:] #Aqui es cantidad de archivos a leer [-5:]
				self.l          = []

				if (self.est not in ['MED-PJIR', 'MED-SIAT']): # MED-UNFM, MED-PJIC

					print '###############################################################'
					print '--------------------       %s -----------------------' %self.est
					print '###############################################################'

					for n in range(len(self.files)):
						print self.files[n]

						if self.files[n][-5:] == '_.txt':
							self.x		= np.genfromtxt(self.files[n],delimiter='\t',dtype=str)
							self.dates	= pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%m/%d/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])

						elif self.files[n][-5:] == '-.txt':
							self.read		= open(self.files[n]).readlines()
							self.begin		= self.read.index(' - Resultados de periodo -\r\n')
							self.x			= np.empty( (len([self.begin+2] + range(self.begin+3,len(self.read),4)),len(self.read[self.begin+2][:-4].split('\t'))),dtype=object )
							self.count		= 0
							for i in [self.begin+2] + range(self.begin+3,len(self.read),4):
								self.x[self.count,:]	= np.array(self.read[i][:-(3 if i==self.begin+2 else 2)].replace(',','.').split('\t'))
								self.count				+= 1

							self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%d/%m/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])

						else:
							
							self.read		= open(self.files[n]).readlines()
							self.begin		= self.read.index(' - Resultados de periodo -\r\n')
							self.x			= np.empty( (len([self.begin+2] + range(self.begin+3,len(self.read),3)),len(self.read[self.begin+2][:-4].split('\t'))),dtype=object )
							self.count		= 0
							## Creo que esta línea sirve para convertir el separador decimal
							for i in [self.begin+2] + range(self.begin+3,len(self.read),3):
								self.x[self.count,:]	= np.array(self.read[i][:-(3 if i==self.begin+2 else 2)].replace(',','.').split('\t'))
								self.count				+= 1

							try:
								if self.files[n] == "/home/calidadaire/ModuloRuido/DatosRuido/Ruido/GIR-SOSN/GIR-SOSN_2017-10-11.txt":
									self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%m/%d/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
								elif self.files[n] == "/home/calidadaire/ModuloRuido/DatosRuido/Ruido/GIR-SOSN/GIR-SOSN 2017 06 08.txt":
									self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%m/%d/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
								elif self.files[n] != "/home/calidadaire/ModuloRuido/DatosRuido/Ruido/GIR-SOSN/GIR-SOSN_20170510.txt":
									try:
										self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%d/%m/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
									except:
										self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%d-%m-%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
								else:
									self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%m/%d/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
							except:
								self.dates = pd.to_datetime([dt.datetime.strptime('%s %s' %(self.x[i,2],self.x[i,3]),'%m/%d/%Y %H:%M:%S').strftime('%Y-%m-%d %H:%M') for i in range(1,self.x.shape[0])])
								pass

						self.X					= pd.DataFrame(self.x[1:,8:],index=self.dates,columns=self.x[0,8:])
						self.X[self.X=='---,-']	= np.NaN
						self.X[self.X=='---.-']	= np.NaN
						self.X[self.X=='']		= np.NaN
						self.X[self.X=='---']		= np.NaN
						self.X[self.X=='-----']		= np.NaN
						self.l.append(self.X.astype(float).dropna())


				else:

					print '###############################################################'
					print '--------------------       %s -----------------------' %self.est
					print '###############################################################'


					for n in range(len(self.files)):
						print self.files[n]
						if self.files[n][-5:] == '_.csv':
							self.x		 		= pd.read_csv(self.files[n])
							self.x['Fechas'] 	= self.x['Date']+self.x['hour']
							self.x 				= self.x.set_index('Fechas')
							self.x.index 		= pd.to_datetime(self.x.index,format='%m/%d/%Y%H:%M:%S')
							self.x 				= self.x[self.x.columns.values[poscol(self.x)]]
							self.x.columns		= map(lambda x: '%s Hz' %x[5:] ,self.x.columns.values)

						elif self.files[n][-5:] == 'x.csv':
							self.x				= pd.read_csv(self.files[n],header=5)
							self.x['Fechas']	= self.x['Date_Hour'].map(lambda x: x.replace('p. m.', 'PM').replace('a. m.', 'AM').replace('p.m.', 'PM').replace('a.m.', 'AM'))
							self.x 				= self.x.set_index('Fechas')
							self.x.index 		= pd.to_datetime(self.x.index,format='%d/%m/%Y %I:%M:%S %p')
							self.x 				= self.x[self.x.columns.values[poscol(self.x)]]
							self.x.columns 		= map(lambda x: '%s Hz' %x[5:] ,self.x.columns.values)

						elif self.files[n][-4:] == '.txt':
							self.x 				= pd.read_csv(self.files[n],delimiter='\t',header=4,decimal=',', index_col=False)
							self.x['Fechas'] 	= self.x['Date_Hour'].map(lambda x: x.replace('p. m.', 'PM').replace('a. m.', 'AM').replace('p.m.', 'PM').replace('a.m.', 'AM')) 
							self.x 				= self.x.set_index('Fechas')
							try:
								try:
									self.x.index 	= pd.to_datetime(self.x.index,format='%d/%m/%Y %I:%M:%S %p')
								except:
									self.x.index 	= pd.to_datetime(self.x.index,format='%d-%m-%Y %I:%M:%S %p')
							except:
								try:
									self.x.index    = pd.to_datetime(self.x.index,format='%d-%m-%Y %H:%M:%S')
								except:
									self.x.index    = pd.to_datetime(self.x.index,format='%d/%m/%Y %H:%M:%S')
							self.x				= self.x[self.x.columns.values[poscol(self.x)]] 
							
							self.x.columns 		= map(lambda x: '%s Hz' %x[5:] ,self.x.columns.values)
						self.x = self.x.astype(float)
						for col in self.x.columns.values: self.x[col] = self.x[col]  - self.AjusteZ[col]
						### Se modifican los nombres de las freq de las estaciones Pulsar por ser distintos
						# a la forma en como se guardan en BD
						### Este es un machetazo a corregir en el futuro
						self.x.columns = self.frecuencias[:28]
						## ^^Ya se verificó que coincidieran los números de las frecuencias y que solo
						## los diferenciara la notación e.g 1,25k y 1k25,31.5 y 32 es el único chambonazo
						
						self.x.index 		= map(lambda x:x.replace(second = 0), self.x.index)
					
						self.l.append(self.x.astype(float).dropna())
				### Arreglitos del manu 1
				self.L[self.est] 		= pd.concat(self.l).sort_index().reindex(columns=self.frecuencias)
				self.L[self.est]		= self.L[self.est][~self.L[self.est].index.duplicated()]
		

			#if (self.estacion == '*') | (self.estacion == 'MED-PJIR'):	
			#	try: self.L['MED-PJIR'].columns = self.L['SAB-SEMS'].columns.values[:-3]
			#	except: pass
#                        if (self.estacion == '*') | (self.estacion == 'MED-UNFM'):                          # TODA LA LINEA ES POR MED-UNFM
#                                try:    self.L['MED-UNFM'].columns = self.L['MED-PLMA'].columns.values[:-3] # TODA LA LINEA ES POR MED-UNFM
#                                except: pass								    # TODA LA LINEA ES POR MED-UNFM
			#if (self.estacion == '*') | (self.estacion == 'MED-ITMR'):
			#	try:	self.L['MED-ITMR'].columns = self.L['SAB-SEMS'].columns.values[:-3]
			#	except: pass
			#if (self.estacion == '*') | (self.estacion == 'MED-SIAT'):
			#	try:	self.L['MED-SIAT'].columns = self.L['SAB-SEMS'].columns.values[:-3]
			#	except: pass

			#MP2018-11-26
			self.L 		= pd.concat(self.L,axis=1)

		if self.Meteorologicas:

			print '\n'
			print '###############################################################'
			print '                       Meteorologia'
			print '###############################################################'
			print '\n'

			self.Estaciones 	= gb.glob('/home/calidadaire/ModuloRuido/DatosRuido/Meteorologia/%s' %(self.estacion) )
			self.Met			= pd.DataFrame()

			for e in self.Estaciones:


				self.meteofiles = sorted(gb.glob('%s/*.txt' %e), key = os.path.getmtime)
				self.meteofiles = self.meteofiles[Nhist:] #Esto aqui es cantidad de archivos a leer [-5:]
				self.est = e[-8:]
				if self.est[-8:] not in ['MED-PJIR','GIR-SOSN']:

					print '###############################################################'
					print '--------------------       %s -----------------------' %self.est
					print '###############################################################'

					self.MetAux = pd.Series ()

					for n in range(len(self.meteofiles)):
						print self.meteofiles[n]
						self.x			= np.genfromtxt(self.meteofiles[n],delimiter='\t',dtype=str)
						self.dates		= []
						for i in range(2,self.x.shape[0]):
							self.hh 		= ('00:00 a' if (self.x[i,1][-1] =='a') | (self.x[i,1][-4:] =='a.m.') else '12:00 a') if (self.x[i,1][:-2] == '12:00') | (self.x[i,1][:-5] == '12:00') else (self.x[i,1] if (self.x[i,1][-1] in ['a','p']) else self.x[i,1][:-3])
							if len(self.hh) < 4:
								self.hh = self.x[i, 1] + '  '
							self.dates.append((dt.datetime.strptime('%s %s' %(self.x[i,0],self.hh[:-2]),'%d/%m/%'+('Y' if len(self.x[i,0])==10 else 'y') +' %H:%M') + dt.timedelta(hours = 0 if self.hh[-1] =='a' else 12) ).strftime('%Y-%m-%d %H:%M'))
						self.dates		= pd.to_datetime(self.dates)


						self.MetAux = self.MetAux.append (pd.Series(self.x[2:,np.where((self.x[0,:]=='Wind') & (self.x[1,:]=='Speed'))[0][0]],index=self.dates).astype(float))

					self.MetAux = self.MetAux.groupby (self.MetAux.index).first ()

					self.Met 			  = self.Met.reindex (self.Met.index | self.MetAux.index)
					self.Met[self.est]                = self.MetAux


	def Ajuste_Tonalidades(self,*args,**kwargs):

		self.LAeq 	= {}
		self.LRAeq	= {}
		print self.L.columns.levels[0].values[np.unique(self.L.columns.labels[0].values())]
		for est in self.L.columns.levels[0].values[ np.unique(self.L.columns.labels[0].values())]:

			self.LAeq[est]=10*np.log10((10.**(self.L[est]/10.)).sum(1))

			print '###############################################################'
			print '----------------------  Ajuste   %s  ----------------------' %est

			self.Tbajo	= pd.DataFrame()
			self.Tmedio	= pd.DataFrame()
			self.Talto	= pd.DataFrame()

			for f in range(1,self.L[est].columns.size-1): # para tomar solo centros de Octavas: range(2,self.L[est].columns.size-1:3)
				print self.frecuencias[f]
				if self.frecuencias[f] in self.frecuencias[:9]:
					self.Tbajo[self.frecuencias[f]]	= self.L[est][self.frecuencias[f]] - (self.L[est][self.frecuencias[f-1]] + self.L[est][self.frecuencias[f+1]])/2.
				elif self.frecuencias[f] in self.frecuencias[9:14]:
					self.Tmedio[self.frecuencias[f]]= self.L[est][self.frecuencias[f]] - (self.L[est][self.frecuencias[f-1]] + self.L[est][self.frecuencias[f+1]])/2.
				else:
					self.Talto[self.frecuencias[f]]	= self.L[est][self.frecuencias[f]] - (self.L[est][self.frecuencias[f-1]] + self.L[est][self.frecuencias[f+1]])/2.

			self.Tbajo[self.Tbajo<8] 							= 0
			self.Tbajo[(self.Tbajo>=8) & (self.Tbajo<=12)]		= 3
			self.Tbajo[self.Tbajo>12]							= 6

			self.Tmedio[self.Tmedio<5]							= 0
			self.Tmedio[(self.Tmedio>=5) & (self.Tmedio<=8)]	= 3
			self.Tmedio[self.Tmedio>8]							= 6

			self.Talto[self.Talto<3] 							= 0
			self.Talto[(self.Talto>=3) & (self.Talto<=5)]		= 3
			self.Talto[self.Talto>5]							= 6

			self.Tajuste				= pd.concat([self.Tbajo,self.Tmedio,self.Talto])

			self.LRAeq[est] 			= self.LAeq[est] + self.Tajuste.max(1)
			self.LRAeq[est] 			= self.LRAeq[est][~self.LRAeq[est].index.duplicated()]

		self.LAeq 		= pd.concat(self.LAeq,axis=1)
		self.LRAeq 		= pd.concat(self.LRAeq,axis=1)





# 	def Indicadores(self,*args,**kwargs):

# #                self.Dia      = kwargs.get('Dia',True)
# #                self.Noche    = kwargs.get('Noche',True)

# 		self.Periodo = kwargs.get('Periodo','D') # La otra opcion seria N

# 		Estaciones   = self.L.columns.levels[0].values
# 		self.NExpo   = pd.DataFrame(columns=Estaciones)
# 		self.NRT     = pd.DataFrame(columns=Estaciones)
# 		self.CS      = pd.DataFrame(columns=Estaciones)
# 		self.DiffDN  = pd.DataFrame(columns=Estaciones)
# 		self.NCR     = pd.DataFrame(columns=Estaciones)
# 		self.LAindDia= pd.DataFrame(columns=Estaciones)
#                 self.LAindNoche= pd.DataFrame(columns=Estaciones)

# 		for est in Estaciones:

# 			# Serie de LAeq cada minunto:
# 			self.LAeq1M=10*np.log10((10.**(self.L[est]/10.)).sum(1))
# 			self.LAeq1M.replace(-np.inf,np.nan, inplace=True) # Cambiar inf por nan
# 			# Quitar datos donde LRAeqH no sea valido
# 			#self.LAeq1M.loc[est][self.FlagH[est]>=3]=np.nan ############ NPI de como rayos hacer esto  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# 			# Si lo quisiera hacer cada hora:
# 	                self.LAeq1H=self.LAeq1M.resample('H').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
# 			self.LAeq1H=self.LAeq1H.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
# 			# Quitar datos donde LRAeqH no sea válido
# 			self.LAeq1H[self.LRAeqH[est][self.LRAeqH[est].isna()].index]=np.nan

# 			# Dependiendo de si sera diurno o nocturno elijo el dataframe analizar
# 			self.LAeq1HD=self.LAeq1H[(self.LAeq1H.index.hour >=7) & (self.LAeq1H.index.hour <21)]
# 			self.LAeq1HN=self.LAeq1H[(self.LAeq1H.index.hour <7) | (self.LAeq1H.index.hour >=21)]

# 			LAindices = self.LAeq1HD if self.Periodo =='D' else self.LAeq1HN

# 			# Nivel de Exposicion Sonora
# 			# calcular equivalente diario a partir de datos horarios
# 			self.LAeq24h    = LAindices.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
# 			# calcular nivel de expo (nivel de ruido del dia acumulando las horas)
# 			self.NExpo[est] = LAindices.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()))
# 			self.NExpo[est].replace(-np.inf,np.nan, inplace=True)

# 			# Nivel de ruido de tráfico
# 			self.NRT[est] = LAindices.resample('D').apply(lambda x: 4*(np.nanpercentile(x,90)-np.nanpercentile(x,10))+np.nanpercentile(x,10)-30)

# 			# Factor de Clima Sonoro
# 			self.CS[est] = LAindices.resample('D').apply(lambda x: np.nanpercentile(x,90)-np.nanpercentile(x,10))

# 			# Diferencia Dia Vs Noche
# 			self.LAindDia  = self.LAeq1HD.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
# 			self.LAindNoche= self.LAeq1HN.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
# 			self.DiffDN[est] = self.LAindDia - self.LAindNoche

# 			# Nivel de contaminación de ruido
# 			self.NCR[est] = self.LAeq24h + 2.56*LAindices.resample('D').std()

# 		Index = {}
# 		Index['CS'] = self.CS
# 		Index['NRT'] = self.NRT
# 		Index['NExpo'] = self.NExpo
# 		Index['NCR'] = self.NCR
# 		Index['DiffDN']=self.DiffDN
# 		return Index

	def Indicadores(self,*args,**kwargs):
		self.Periodo = kwargs.get('Periodo','D') # La otra opcion seria N
        #llamar los datós validados por hora
		self.LAeq1H=self.ruido.consulta(variable='LRAeq',tipo='H',fechai=self.ruido.fechai,fechaf=self.ruido.fechaf)['LRAeqH']
        #Separar en Diurno y Nocturno
		self.LAeq1HD=self.LAeq1H[(self.LAeq1H.index.hour >=7) & (self.LAeq1H.index.hour <21)]
		self.LAeq1HN=self.LAeq1H[(self.LAeq1H.index.hour <7) | (self.LAeq1H.index.hour >=21)]
        # se crea un Data Frame dependiendo de si es diurno o Nocturno
		LAindices = self.LAeq1HD if self.Periodo =='D' else self.LAeq1HN

        # Nivel de Exposicion Sonora
        # calcular equivalente diario a partir de datos horarios
		self.LAeq24h    = LAindices.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
        # calcular nivel de expo (nivel de ruido del dia acumulando las horas)
		self.NExpo = LAindices.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()))
		self.NExpo.replace(-np.inf,np.nan, inplace=True)

        # Nivel de ruido de tráfico
		self.NRT = LAindices.resample('D').apply(lambda x: 4*(np.nanpercentile(x,90)-np.nanpercentile(x,10))+np.nanpercentile(x,10)-30)

        # Factor de Clima Sonoro
		self.CS = LAindices.resample('D').apply(lambda x: np.nanpercentile(x,90)-np.nanpercentile(x,10))

        # Diferencia Dia Vs Noche
		self.LAindDia  = self.LAeq1HD.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
		self.LAindNoche= self.LAeq1HN.resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
		self.DiffDN = self.LAindDia - self.LAindNoche

        # Nivel de contaminación de ruido
		self.NCR = self.LAeq24h + 2.56*LAindices.resample('D').std()

		Index = {}
		Index['CS'] = self.CS
		Index['NRT'] = self.NRT
		Index['NExpo'] = self.NExpo
		Index['NCR'] = self.NCR
		Index['DiffDN']=self.DiffDN

		return Index

	def Filtro_Ruido(self,*args,**kwargs):

		self.save_csv	= kwargs.get('save_csv',False)

		########################################################################
		#                      Suma Logaritmica horaria
		########################################################################
		self.LRAeqH		= self.LRAeq.resample('h').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))
		self.LRAeqH 		= self.LRAeqH.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))

		self.FlagH		= pd.DataFrame(index=self.LRAeqH.index, data=np.ones(self.LRAeqH.values.shape), columns=self.LRAeqH.columns)


		########################################################################
		#                            Lectura Meteo
		########################################################################
	        #P de Pluvio :O
		#self.EstacionesP    	= {'GIR-BOTJ':31,'MED,PJIC':41,'SAB-SEMS':146, 'MED-SIAT':60,'ITA-SAMA':395,'ITA-ACUA':36} #'ITA-CODI':36 'BEL-ALCA': 74, 'MED-UNFM': 60, 'MED-PLMA':45, 'GIR-SOSN':31, 'MED-PJIC':41
#		self.EstacionesP    	= {'GIR-BOTJ':31,'MED-PLMA':45,'ITA-CODI':36,'SAB-SEMS':146} # 'BEL-ALCA': 74, 'MED-UNFM': 60
		#self.EstacionesThiess   = {'MED-PJIR':198 , 'MED-SIAT':1019, 'MED-ZOOL':198} # 'GIR-SOSN':254 
		#self.EstacionesVaisala  = {'CEN-TRAF':202,'ITA-ACUA':206}
		self.EstacionesAire	= {'ITA-SAMA':28}
		self.EstacionesP = dict(zip(self.EstR.loc[self.EstR.Pluviometro>0]['Nombre'].values,self.EstR.loc[self.EstR.Pluviometro>0]['Pluviometro'].values))
		self.EstacionesThiess = dict(zip(self.EstR.loc[self.EstR.Thiess>0]['Nombre'].values,self.EstR.loc[self.EstR.Thiess>0]['Thiess'].values))
		self.EstacionesVaisala= dict(zip(self.EstR.loc[self.EstR.Vaisala>0]['Nombre'].values,self.EstR.loc[self.EstR.Vaisala>0]['Vaisala'].values))

#		self.Pluvio 		= self.Aire.Aire_db(Variable='PPT',PluviometroJAL=True,Estaciones=list(set(self.EstacionesP.values()))) # CON JAL para histricos pesados
		self.Pluvio 		= self.Aire.Aire_db(Variable='PPT',Pluviometro=True,Estaciones=list(set(self.EstacionesP.values())))
		self.Pluvio		= self.Pluvio[self.LRAeqH.index[0]:self.LRAeqH.index[-1]] #Para que el indice llegue hasta la misma hora que ruido
		self.Pluvio 		= self.Pluvio.stack(0).unstack(1).resample('h').sum()
		#self.Pluvio		= self.Pluvio[:-24] #['2018-04-01 00:00:00'] #MoodificaMPx


                if  dt.datetime.strptime(self.Fechaf[:10], "%Y-%m-%d") > dt.datetime(2017,10,15):  # Desde el octubre de 2017 en adelante lee Thies
                        self.MeteoThiess        = self.Aire.Aire_db(Estaciones=list(set(self.EstacionesThiess.values())),thiess=True)
                        self.PThiess            = self.MeteoThiess['p'].resample('h').sum() # Precipitacion de la Thiess (GIR-SOSN, MED-PJIC, MED-SIAT)
                        self.VThiess            = self.MeteoThiess['vv'].resample('h').mean() # Tomar por separado el viento de la precipitacion

                        #self.codThiess={'MED-PJIR':198, 'MED-SIAT':1019,'MED-ZOOL':198} #,'MED-PJIC':198} # 'GIR-SOSN':254, Se cambió MED-PJIC por MED-PJIR
			self.codThiess=dict(zip(self.EstR.loc[self.EstR['Thiess']>0,:]['Nombre'].values,self.EstR.loc[self.EstR['Thiess']>0,:]['Thiess'].values))
			#self.PVaisala		= self.Aire.Aire_db(varvaisala=['rc'],Vaisala=True,Estaciones=[202]) ## a partir de mayo del 2019
			self.PVaisala		= self.Aire.Aire_db(varvaisala=['rc'],Vaisala=True,Estaciones=list(np.unique(self.EstR.loc[self.EstR['Vaisala']>0,'Vaisala'].values)))
			#self.VVaisala		= self.Aire.Aire_db(varvaisala=['sm'],Vaisala=True,Estaciones=[202])
			self.VVaisala		= self.Aire.Aire_db(varvaisala=['sm'],Vaisala=True,Estaciones=list(np.unique(self.EstR.loc[self.EstR['Vaisala']>0,'Vaisala'].values)))
			self.PVaisala           = self.PVaisala.resample('h').sum()/1000.
			self.VVaisala           = self.VVaisala.resample('h').mean()/10.

			self.VAire		= self.Aire.Aire_db(Meteorologicas=True,ValidadoSiata=True,Estaciones=self.EstacionesAire.values(),Variable='VViento_SSR')
                ########################################################################
                #                         Meteorología vientos
                ########################################################################

#               print self.Met

#               self.Met        = pd.concat([self.VThiess[[198,254,1019]],self.Met[self.Met.columns[self.Met.columns!="MED-SIAT"]]],axis=1)
#               self.Met.rename(columns={198:"MED-PJIC",254:"GIR-SOSN",1019:"MED-SIAT"},inplace=True)

                # Si quiero leer datos de antes de diciembre de 2017, SOSN es BOTJ y PJIC se saca de meteo-aire
                if dt.datetime.strptime(self.Fechai[0:10], "%Y-%m-%d") < dt.datetime(2017,12,01):

			self.Met = self.Aire.Aire_db(MeteoRuido=True,Variable='VViento_SSR')
                        self.Met['GIR-SOSN']=self.Met['GIR-BOTJ'] # Ponerle a SOSN los datos de BOTJ
                        self.Aire.Read_db(Meteorologicas=True,ValidadoSiata=True) # Leer Meteo de Aire para PJIC
                        self.Met = pd.concat([self.Aire.Meteo.stack(0)[['MED-PJIR']].xs('VViento_SSR',level=1),self.Met],axis=1)

                        # Para SOSN, desde diciembre de 2017 es con Thies
                        if dt.datetime.strptime(self.Fechaf[0:10], "%Y-%m-%d") > dt.datetime(2017,12,01):
                                self.Met["GIR-SOSN"]['2017-12-01':self.VThiess.index[-1]]=self.VThiess[254]['2017-12-01':]

                        # Para PJIC desde Octubre de 2017 es con Thies
                        if dt.datetime.strptime(self.Fechaf[0:10], "%Y-%m-%d") > dt.datetime(2017,10,1):
                                self.Met["MED-PJIR"]['2017-10-01':self.VThiess.index[-1]]=self.VThiess[198]['2017-10-01':] #Se cambia MED-PJIC por MED-PJIR

                # 2018
                elif dt.datetime.strptime(self.Fechai[0:10], "%Y-%m-%d") < dt.datetime(2018,12,01):
                        self.Met        = pd.concat([self.VThiess[[198,254]],self.Met[self.Met.columns]],axis=1)
                        self.Met.rename(columns={198:"MED-PJIR",254:"GIR-SOSN"},inplace=True) #Se cambia MED-PJIC por MED-PJIR

		else: ### del 2018 en adelante modificar este 
			print self.Fechai, self.Fechaf
			self.Met = self.Aire.Aire_db(MeteoRuido=True,Variable='VViento_SSR')
			self.Met = self.Met.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
			#self.VThiess.rename(columns={198:'MED-PJIR',1019:'MED-SIAT',198:'MED-ZOOL'},inplace=True) #Se cambia MED-PJIC por MED-PJIR
			self.VThiess.rename(columns={v: k for k, v in self.EstacionesThiess.items()},inplace=True)
			#self.VVaisala.rename(columns={202:'CEN-TRAF'},inplace=True)
			self.VVaisala.rename(columns={v: k for k, v in self.EstacionesVaisala.items()},inplace=True)
			#self.VAire.rename(columns={28:'ITA-SAMA'},inplace=True)
			self.VAire.rename(columns={v: k for k, v in self.EstacionesAire.items()},inplace=True)
			#self.VThiess['MED-PJIR']=self.VThiess['MED-ZOOL'] ## esto porque las dos estaciones tienen la misma thies subsidiaria
			try:
		                self.VThiess['MED-PJIR']=self.VThiess['MED-ZOOL']
			except:
		                self.VThiess['MED-ZOOL']=self.VThiess['MED-PJIR']

			for est in self.EstacionesAire.keys():
                		self.VThiess[est]=self.VAire[est]
                
            		for est in self.EstacionesVaisala.keys():
                		self.VThiess[est]=self.VVaisala['sm'][est]
			#self.VThiess['ITA-SAMA']=self.VAire['ITA-SAMA']
			#self.VThiess['CEN-TRAF']=self.VVaisala['sm']

			for est in self.VThiess.columns:
                
                		try:
                    			MeteoSub=pd.concat([self.VThiess[est],self.Met[est]],axis=1)
                    			MeteoSub.columns=['t','bd']
				    	self.Met[est]=MeteoSub['bd'].add(MeteoSub['t']*(np.logical_not(MeteoSub['bd']>0)), fill_value=0)
                		except:
                    			MeteoSub=self.VThiess[est]
                    			#MeteoSub.columns=['t']
				    	self.Met[est]=MeteoSub #['t']
                    
                		self.Met = self.Met.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))



#			for est in self.VThiess.columns:
#				MeteoSub=pd.concat([self.VThiess[est],self.Met[est]],axis=1)
#				MeteoSub.columns=['t','bd']
#				self.Met[est]=MeteoSub['bd'].add(MeteoSub['t']*(np.logical_not(MeteoSub['bd']>0)), fill_value=0)

 #               self.Met = self.Met.reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))

                ########################################################################
                #                             Filtro Viento
                ########################################################################

                for var in self.LRAeq.columns.values:
                        if ((self.Met[var][(self.Met[var]>3)]).size >0 ): #Cambiar con otras estaciones de meteo
                                self.FlagH[var][self.Met[var][(self.Met[var]>3)].index] = 3.2



                ########################################################################
		# 				Filtro Lluvia
                ########################################################################
		### Falta algo que ponga los flags - Maria Paula del Futuro 
		if dt.datetime.strptime(self.Fechai[:10], "%Y-%m-%d") >= dt.datetime(2018,12,01):
			Data=self.Aire.Aire_db(MeteoRuido=True,Variable='PLiquida_SSR')
			
			for est in self.EstacionesThiess.keys():
                
                	##Se redefine resampleando
                		self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].resample('H').sum()
                ##Se redefine reindexando
                		self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))
                
                		try:
                    			Data[est]=Data[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
                    			MeteoSub=pd.concat([Data[est],self.MeteoThiess['p'][self.EstacionesThiess[est]]],axis=1)
                    			MeteoSub.columns=['t','bd']
                    			MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0)), fill_value=0)
                    
                		except:
		                        MeteoSub=pd.DataFrame(columns=['t'])
                    			MeteoSub['t']=self.MeteoThiess['p'][self.EstacionesThiess[est]]
                    
		                self.FlagH[est].loc[MeteoSub[MeteoSub['t']>0.2].index] = 3.1

				

			### Subsidiamos Vaisala
			for est,code in self.EstacionesVaisala.items():
                
                		try:
                    			Data[est]=Data[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
	                                MeteoSub=pd.concat([Data[est],self.PVaisala['rc'][code]],axis=1)
                    			MeteoSub.columns=['t','bd']
                    			MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0)), fill_value=0)
                    
                		except:
                    			MeteoSub=pd.DataFrame(columns=['t'])
                    			MeteoSub['t']=self.PVaisala['rc'][code]
                    
                		self.FlagH[est].loc[MeteoSub[MeteoSub['t']>0.2].index] = 3.1


			MeteoSub=Data[['ITA-SAMA']]
            		MeteoSub.columns=['t']
	                self.FlagH['ITA-SAMA'].loc[MeteoSub[MeteoSub['t']>0.2].index] = 3.1
	
			"""for est in self.EstacionesThiess.keys():
				if est=='MED-PJIR' or est=='MED-PJIC': #Se cambia MED-PJIC por MED-PJIR
					
					self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].resample('H').sum()
					self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='T'))
					MeteoSub=pd.DataFrame(columns=['t'])
					MeteoSub['t']=self.MeteoThiess['p'][self.EstacionesThiess[est]]
				else:
					self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].resample('H').sum()
					self.MeteoThiess['p'][self.EstacionesThiess[est]]=self.MeteoThiess['p'][self.EstacionesThiess[est]].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
					Data[est]=Data[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
					MeteoSub=pd.concat([Data[est],self.MeteoThiess['p'][self.EstacionesThiess[est]]],axis=1)
					MeteoSub.columns=['t','bd']
					MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0)), fill_value=0)
				self.FlagH[est].loc[MeteoSub[MeteoSub['t']>0.2].index] = 3.1

			for est in ['ITA-SAMA','GIR-BOTJ','SAB-SEMS','CEN-TRAF']: # 'MED-PLMA'
				Data[est]=Data[est].reindex(pd.date_range(self.Fechai,self.Fechaf,freq='H'))
				if est=='CEN-TRAF':MeteoSub=pd.concat([Data[est],self.PVaisala['rc'][self.EstacionesVaisala[est]]],axis=1)
				else: MeteoSub=pd.concat([Data[est],self.Pluvio[str(self.EstacionesP[est])].mean(axis=1).resample('H').sum()],axis=1)
				MeteoSub.columns=['t','bd']
				MeteoSub['t'].add(MeteoSub['bd']*(np.logical_not(MeteoSub['t']>=0)), fill_value=0)
				self.MeteoSub=MeteoSub.copy()
				## pluvio ITA-CODI mala
				self.FlagH[est].loc[MeteoSub[MeteoSub['t' if est!='ITA-CODI' else 'bd']>0.2].index] = 3.1

		if dt.datetime.strptime(self.Fechai[:10], "%Y-%m-%d") < dt.datetime(2018,12,01):
			for var in self.LRAeq.columns.values:

 				if var not in ['MED-SIAT','MED-PJIR','MED-PJIC'] : # Invalidar datos donde P sea mayor a 0.2 usando Pluvio siempre 
					if (self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)]).size >0:
#						self.LRAeqH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = np.NaN
						self.FlagH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = 3.1

				else: # Invalidar datos en donde P sea mayor a 0.2 para SIAT, PJIC y SOSN con Thies o Pluvio segun la fecha

					# Desde dic 2017 estaban las tres thiess instaladas
					if dt.datetime.strptime(self.Fechai[:10], "%Y-%m-%d") >= dt.datetime(2017,12,01):
						if (self.PThiess[self.codThiess[var]][self.PThiess[self.codThiess[var]]>0.2]).size >0:
							self.FlagH[var].loc[self.PThiess[self.codThiess[var]][self.PThiess[self.codThiess[var]]>0.2].index] = 3.1
#							self.LRAeqH[var].loc[self.PThiess[self.codThiess[var]][self.PThiess[self.codThiess[var]]>0.2].index] = np.NaN

					# Antes de dic 2017 usar Pluvio
					elif dt.datetime.strptime(self.Fechaf[0:10], "%Y-%m-%d") < dt.datetime(2017,12,01):
        		                        if (self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)]).size >0:
#	                	                       self.LRAeqH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = np.NaN
							self.FlagH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = 3.1

					# Para consultas que combinen ambos
					else:
                	                        if (self.Pluvio[str(self.EstacionesP[var])][:'2017-11-30 23:00'][(self.Pluvio[str(self.EstacionesP[var])]['p1'][self.Fechai:'2017-11-30 23:00']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2'][:'2017-01-12 00:00']>0.2)]).size >0:
#                       	                       self.LRAeqH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = np.NaN
							self.FlagH[var].loc[self.Pluvio[str(self.EstacionesP[var])][(self.Pluvio[str(self.EstacionesP[var])]['p1']>0.2) & (self.Pluvio[str(self.EstacionesP[var])]['p2']>0.2)].index] = 3.1

                                        	if (self.PThiess[self.codThiess[var]]['2017-12-01 00:00':][self.PThiess[self.codThiess[var]]['2017-12-01 00:00':]>0.2]).size >0:
#                                               	 self.LRAeqH[var].loc[self.PThiess[self.codThiess[var]][self.PThiess[self.codThiess[var]]>0.2].index] = np.NaN
	                                                self.FlagH[var].loc[self.PThiess[self.codThiess[var]][self.PThiess[self.codThiess[var]]>0.2].index] = 3.1"""


		########################################################################
		#         Flags de Faltantes Horarios e invalidados por yo :B
		########################################################################
		#Faltantes
		self.FlagH[np.isnan(self.LRAeqH)]=4

		#Invalidados
		#self.FlagH['ITA-CODI']['2016-10-12 11:00':'2016-10-27 08:00']=3 #se comento cuando se incluyo ITA-SAMA 2019-10-30
		self.FlagH['GIR-BOTJ']['2016-12-10 23:00':'2016-12-22 11:00']=3
		self.FlagH['MED-ZOOL']['2019-09-26 09:00':'2019-09-26 10:00']=3
		self.FlagH['MED-SIAT']['2017-07-31 08:00':'2017-08-03 05:00']=4

		########################################################################
		#                   Indices y Flags Diurnos, Nocturnos y Diario
		########################################################################

		self.LRAeqHVal = self.LRAeqH.copy(deep=True)
		self.LRAeqHVal[self.FlagH>=3]=np.nan

		# Diurno
		self.LRAeqD	= self.LRAeqHVal[(self.LRAeqHVal.index.hour >=7) & (self.LRAeqHVal.index.hour <21)].resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count())) #.unstack(1)
		# Flags
                self.FlagDcount = self.LRAeqHVal[(self.LRAeqHVal.index.hour >=7) & (self.LRAeqHVal.index.hour <21)].resample('D').apply(lambda x: x.count()) 
                self.FlagD = self.FlagDcount.copy(deep=True)

                self.FlagD[self.FlagDcount==0] = 4
                self.FlagD[self.FlagDcount==1] = 3
                self.FlagD[(self.FlagDcount<=4) & (self.FlagDcount>=2)] = 2
                self.FlagD[self.FlagDcount>=5] = 1

		# Nocturno
		self.LRAeqN	= self.LRAeqHVal[(self.LRAeqHVal.index.hour <7) | (self.LRAeqHVal.index.hour >=21)].resample('D').apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/x.count()))# .unstack(1)
                # Flags
		self.FlagNcount = self.LRAeqHVal[(self.LRAeqHVal.index.hour <7) | (self.LRAeqHVal.index.hour >=21)].resample('D').apply(lambda x: x.count()) 
                self.FlagN = self.FlagNcount.copy(deep=True)

                self.FlagN[self.FlagNcount==0] = 4
                self.FlagN[self.FlagNcount==1] = 3
                self.FlagN[(self.FlagNcount<=4) & (self.FlagNcount>=2)] = 2
                self.FlagN[self.FlagNcount>=5] = 1

		# Diurno/Nocturno
		self.LRAeqDN	= 10*np.log10( (14*(10.**(self.LRAeqD/10.)) + 10*(10.**((self.LRAeqN + 10)/10.)))/24)
                # Flags
		self.FlagDNcount = self.LRAeqHVal.resample('D').apply(lambda x: x.count()) 
                self.FlagDN = self.FlagDNcount.copy(deep=True)

                self.FlagDN[self.FlagDNcount==0] = 4
                self.FlagDN[self.FlagDNcount==1] = 3
                self.FlagDN[(self.FlagDNcount<=4) & (self.FlagDNcount>=2)] = 2
                self.FlagDN[self.FlagDNcount>=5] = 1
		self.FlagDN[(self.FlagD==4) | (self.FlagN==4)] = 4 # Si el diurno o el noctruno son nan, el DN también lo es

		self.LR = pd.concat({'LRAeqH':self.LRAeqH,'LRAeqD':self.LRAeqD,'LRAeqN':self.LRAeqN,'LRAeqDN':self.LRAeqDN},axis=1)

		if self.save_csv: self.LR.to_csv('/home/calidadaire/ModuloRuido/Informe/Datos/LR.csv') #Buscar carpeta


	def Plot_Ruido_Norma(self,df,est,*args,**kwargs):

		fontsize		= kwargs.get('fontsize',12)
		colors			= kwargs.get('colors',[[0.69,0.87,0.93],[0.61,0.82,0.88],[0.32,0.71,0.77],[0.21,0.60,0.65],[0.0156,0.486,0.556],[0.007,0.32,0.36],[0.0078,0.227,0.26]])
		textsave		= kwargs.get('textsave','')
		path			= kwargs.get('path','sjaramillo@siata.gov.co:/var/www/CalidadAire/Figuras/Ruido/') 
		ylim			= kwargs.get('ylim',(30,100))
		InfoMes			= kwargs.get('InfoMes',True)

		########################################################################
		#                                 Plot
		########################################################################

		plt.close('all')
		fig = plt.figure(figsize=(df.index.size*.35,3),facecolor='w',edgecolor='w')
		ax = fig.add_subplot(111)
		plt.rcParams["ytick.labelsize"]=fontsize


		for spinename, spine in ax.spines.iteritems():
			spine.set_visible(False)

		ax.spines['left'].set_visible(True)
		ax.spines['left'].set_color((0.45, 0.45, 0.45))
		ax.tick_params(top='off', right='off',bottom='off',left='on',which='both',color=(0.45, 0.45, 0.45))

		df.plot(kind='bar',ax=ax,width=.8,colors=[colors[1],colors[3]],edgecolor='w',ylim=ylim)

		#Ticks
		ticks=ax.get_xticklabels()
		#ax.rcParams["ytick.labelsize"]=12
		ax.set_xticklabels([df.index[i].strftime('%d') for i in range(len(ticks))],rotation='horizontal',fontsize=fontsize,weight='heavy')
		ax.text(0,ylim[0]-(ylim[1]-ylim[0])*.2,df.index[0].strftime('%b-%Y'),fontsize=fontsize,color='k',weight='heavy',ha='left')
		ax.set_ylabel(self.label['Ruido'],fontsize=fontsize,color=(0.45, 0.45, 0.45))
		ax.set_xlabel(u'Día',fontsize=fontsize,color='k',weight='heavy')
		plt.setp(ax.get_yticklabels(),color=(0.45, 0.45, 0.45))

		ax.axhline(self.norma_ruido[est][2],color=colors[5],lw=2,ls='--')
		ax.axhline(self.norma_ruido[est][1],color=colors[6],lw=2,ls='--')

		ticks=ax.get_xticks()
		ax.annotate('Norma Diurna' , xy=(ticks[-1]*.2,self.norma_ruido[est][1]), xytext=(ticks[-1]*.2, ylim[1]*.95),va='center',ha='center',fontsize=fontsize,weight='bold',
							color=colors[6],arrowprops=dict(facecolor=colors[6],edgecolor=colors[6], shrink=0.00,width=.5,headwidth=5),
							bbox=dict(facecolor=colors[0], edgecolor='none', boxstyle='round',alpha=.2))

		ax.annotate('Norma Nocturna' , xy=(ticks[-1]*.8,self.norma_ruido[est][2]), xytext=(ticks[-1]*.8, ylim[1]*.95),va='center',ha='center',fontsize=fontsize,weight='bold',
							color=colors[5],arrowprops=dict(facecolor=colors[5],edgecolor=colors[5], shrink=0.00,width=.5,headwidth=5),
							bbox=dict(facecolor=colors[0], edgecolor='none', boxstyle='round',alpha=.2))
		#Legend
		leg = ax.legend(bbox_to_anchor=(1,-.17),loc='center right',fontsize=fontsize,framealpha=0.3,ncol=2) #(1.03,0.5)
		leg.get_frame().set_linewidth(0.0)

		ax.set_title(self.EstR['Nombre_Estacion'][self.EstR['Nombre'] == est].values[0],loc='right',fontsize=fontsize,fontproperties=prop_2)

		if InfoMes:
			plt.savefig('/home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_Norma%s.pdf' %(textsave),bbox_inches='tight')
			os.system('scp /home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_Norma%s.pdf %s' %(textsave,path))

		else:
			plt.savefig('/home/calidadaire/ModuloRuido/Figuras/Ruido_Norma%s.pdf' %(textsave),bbox_inches='tight')
			os.system('scp /home/calidadaire/ModuloRuido/Figuras/Ruido_Norma%s.pdf %s' %(textsave,path))

	def Plot_Ruido_DiurnoNocturno(self,df,est,*args,**kwargs):

		fontsize		= kwargs.get('fontsize',12)
		colors			= kwargs.get('colors',[[0.69,0.87,0.93],[0.61,0.82,0.88],[0.32,0.71,0.77],[0.21,0.60,0.65],[0.0156,0.486,0.556],[0.007,0.32,0.36],[0.0078,0.227,0.26]])
		textsave		= kwargs.get('textsave','')
		path			= kwargs.get('path','sjaramillo@siata.gov.co:/var/www/CalidadAire/Figuras/Ruido/') 
		ylim			= kwargs.get('ylim',(30,100))
		InfoMes			= kwargs.get('InfoMes',True)

		########################################################################
		#                                Plot
		########################################################################

		plt.close('all')
		fig = plt.figure(figsize=(df.index.size*.35,3),facecolor='w',edgecolor='w')
		ax = fig.add_subplot(111)
		plt.rcParams["ytick.labelsize"]=fontsize

		for spinename, spine in ax.spines.iteritems():
			spine.set_visible(False)

		ax.tick_params(top='off', right='off',bottom='off',left='off',which='both')

		lims=np.linspace(50,100,7)
		poscolor=df.apply(lambda x: np.abs(lims -x).argmin()).values
		cc=[colors[i] for i in poscolor]

		df.plot(kind='bar',ax=ax,width=.75,colors=cc,edgecolor='w',ylim=ylim,legend=False)

		#Ticks
		ticks=ax.get_xticklabels()
		ax.set_xticklabels([df.index[i].strftime('%d') for i in range(len(ticks))],rotation='horizontal',fontsize=fontsize,weight='heavy')
		ax.text(0,ylim[0]-(ylim[1]-ylim[0])*.2,df.index[0].strftime('%b-%Y'),fontsize=fontsize,color='k',weight='heavy',ha='left')
		ticks=ax.get_xticks()
		ax.text(ticks[-1],ylim[0]-(ylim[1]-ylim[0])*.2,'LRAeqDN',fontsize=fontsize,color='k',ha='right')
		ax.set_ylabel(self.label['Ruido'],fontsize=fontsize,color=(0.45, 0.45, 0.45))
		ax.set_xlabel(u'Día',fontsize=fontsize,color='k',weight='heavy')
		ax.set_yticklabels([])
		ax.set_title(self.EstR['Nombre_Estacion'][self.EstR['Nombre'] == est].values[0],loc='right',fontsize=fontsize,weight='bold')

		rects = ax.patches
		for rect in rects:
			height = rect.get_height()
			ax.text(rect.get_x() + rect.get_width()/2. , height*1.02, '%.f' %height if height!=0 else ' ', ha='center',va='bottom',fontsize=fontsize,)

		if InfoMes:
			plt.savefig('/home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_DiurnoNocturno%s.pdf' %(textsave),bbox_inches='tight')
			os.system('scp /home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_DiurnoNocturno%s.pdf %s' %(textsave,path))
		else:
			plt.savefig('/home/calidadaire/ModuloRuido/Figuras/Ruido_DiurnoNocturno%s.pdf' %(textsave),bbox_inches='tight')
			os.system('scp /home/calidadaire/ModuloRuido/Figuras/Ruido_DiurnoNocturno%s.pdf %s' %(textsave,path))

	def Plot_Ruido_Semanal(self,*args,**kwargs):

		ylim 		= kwargs.get('ylim',(50,82))
		path 		= kwargs.get('path','sjaramillo@siata.gov.co:/var/www/CalidadAire/Figuras/Ruido/')
		textsave	= kwargs.get('textsave','')
		save_csv	= kwargs.get('save_csv',False)
		InfoMes		= kwargs.get('InfoMes',True)

		Dias 	= {0:'Lunes',1:'Martes',2:'Miércoles',3:'Jueves',4:'Viernes',5:'Sábado',6:'Domingo',7:'Lun-Vie',8:'Sab-Dom'}
		color = [[0.69,0.87,0.93],[0.61,0.82,0.88],[0.32,0.71,0.77],[0.21,0.60,0.65],[0.0156,0.486,0.556],[0.007,0.32,0.36],[0.0078,0.227,0.26],'k']*3

		#Dias de la semana Diurnos y nocturnos
		LRAeqWD = self.LR.LRAeqD.groupby(lambda x:x.weekday).apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ x.count() ))
		LRAeqWN = self.LR.LRAeqN.groupby(lambda x:x.weekday).apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ x.count() ))

		#En semana Diurno y nocturno
		LRAeqLVN= self.LR.LRAeqN[(self.LR.LRAeqH.index.weekday <5)].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN)))
		LRAeqLVD= self.LR.LRAeqD[(self.LR.LRAeqH.index.weekday <5)].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN)))

		#Fin de semana Diurno y nocturno
		LRAeqFN= self.LR.LRAeqN[(self.LR.LRAeqH.index.weekday >=5)].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN)))
		LRAeqFD= self.LR.LRAeqD[(self.LR.LRAeqH.index.weekday >=5)].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN)))

		#Add
		LRAeqWD		= LRAeqWD.append(pd.DataFrame({7:LRAeqLVD}).T)  # 7:L-V
		LRAeqWD		= LRAeqWD.append(pd.DataFrame({8:LRAeqFD}).T)   # 8: S-D

		#Add
		LRAeqWN		= LRAeqWN.append(pd.DataFrame({7:LRAeqLVN}).T)  # 7:L-V
		LRAeqWN		= LRAeqWN.append(pd.DataFrame({8:LRAeqFN}).T)   # 8: S-D

		#estaciones = ['CEN-TRAF', 'GIR-BOTJ', 'GIR-SOSN', 'ITA-ACUA', 'ITA-CODI',
       		#	      'ITA-SAMA', 'MED-PJIC', 'MED-PJIR', 'MED-PLMA', 'MED-SIAT',
                #              'MED-ZOOL', 'SAB-SEMS']
		
		c,lv=0,['Nocturno','Diurno']
		for df in [LRAeqWN,LRAeqWD]:
			plt.close('all')
			fig = plt.figure(figsize=(9.5,3),facecolor='w',edgecolor='w')
			ax=fig.add_subplot(111)
			ax.spines['top'].set_visible(False)
			ax.spines['right'].set_visible(False)
			ax.spines['left'].set_color((0.45, 0.45, 0.45))
			ax.spines['bottom'].set_color((0.45, 0.45, 0.45))
			ax.tick_params(top='off', right='off',bottom='off',left='on',which='both',colors=(0.45, 0.45, 0.45),labelsize='medium')

			estaciones = self.EstR[self.EstR['Nombre'].isin( df.columns.values)].sort_values(by='Latitud',ascending=False)['Nombre'].values

			df[estaciones].plot(kind='bar',ax=ax,width=0.8,color=color[:df.columns.size],lw=0.05,edgecolor='w',ylim=ylim) 
			ax.yaxis.grid(True,alpha=.4,zorder=1)

			leg = ax.legend(bbox_to_anchor=(.47,-.12),loc='upper center',fontsize='small',ncol=4)
			leg.get_frame().set_edgecolor((0.45, 0.45, 0.45))
			for text in leg.get_texts(): plt.setp(text, color = (0.45, 0.45, 0.45))

			xticks	= Dias.values()[:-2]
			ax.set_xticklabels(xticks,rotation='horizontal',fontproperties=prop_1)
			ax.text(7,ylim[0]-(ylim[1]-ylim[0])*.055,Dias.values()[-2],fontsize='medium',fontproperties=prop_2,color=(0.45, 0.45, 0.45),ha='center',va='center')
			ax.text(8,ylim[0]-(ylim[1]-ylim[0])*.055,Dias.values()[-1],fontsize='medium',fontproperties=prop_2,color=(0.45, 0.45, 0.45),ha='center',va='center')
			plt.setp(ax.get_yticklabels(),fontproperties= prop_1)
			ax.set_ylabel(self.label['Ruido'],color=(0.45, 0.45, 0.45),fontproperties=prop_1)

			if InfoMes:
				plt.savefig('/home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_Semana_%s%s.pdf' %(lv[c],textsave),bbox_inches='tight')
				os.system('scp /home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_Semana_%s%s.pdf %s' %(lv[c],textsave,path))
			else:
				plt.savefig('/home/calidadaire/ModuloRuido/Figuras/Ruido_Semana_%s%s.pdf' %(lv[c],textsave),bbox_inches='tight')
				os.system('scp /home/calidadaire/ModuloRuido/Figuras/Ruido_Semana_%s%s.pdf %s' %(lv[c],textsave,path))
			c+=1
		self.LRAeqWN=LRAeqWN
		self.LRAeqWD=LRAeqWD
		if save_csv: pd.concat({'LRAeqWN':LRAeqWN,'LRAeqWD':LRAeqWD},axis=1).to_csv('/home/calidadaire/ModuloRuido/Informe/Datos/LRAeqW.csv')

	def Insert_Into_Noise(self,*args,**kwargs):

		self.Aire.Fechai				= kwargs.get('Fechai','2015-10-01 09:00')
		self.Aire.Fechaf				= kwargs.get('Fechaf',dt.datetime.now().strftime('%Y-%m-%d 00:00'))

		self.cc				= 0

		for est in self.EstR[self.EstR['Ruido']==1]['Nombre'].values:
#		for est in ['MED-PLMA']:
#			if est != "MED-SIAT":
#				continue

			if self.cc > 10**6: break

			self.codigoSerial 	= self.EstR[self.EstR['Nombre']==est].index.values[0]
			self.Read_Noise_txt(estacion=est,Meteorologia=False)

			self.df 				= self.L[est][self.Fechai:self.Fechaf]
			self.df.dropna(how='all',inplace=True)

			try:
				self.L 			= self.Aire.Aire_db(Variable='Ruido',Estaciones=[self.codigoSerial],Ruido=True)
				self.fechas 	= self.df.index.difference(self.L.index)
			except:
				self.fechas 	= self.df.index

			print '######################################################'
			print '-------------------%s---------------------------' %est

			self.cols 			= str(map(lambda x: self.frec_ruido[x],self.df.columns.values)).strip('[]').replace("'","")
			self.cols_calidad 	= str(map(lambda x: 'calidad_%s' %self.frec_ruido[x],self.df.columns.values)).strip('[]').replace("'","")
			self.df 			= self.df.reindex(self.fechas)
			self.L 				= []
			self.host				= "192.168.1.74"
			self.user				= "siataRedAire_M"
			self.passwd 			= "M0d_CalidadA1r3"
			self.dbname 			= "siataRedAire" 

			for i in range(self.fechas.size):
				if self.cc > 10**6: break
				self.cc				+= 1
				self.fecha_hora 	= self.fechas[i].strftime('%Y-%m-%d %H:%M:%S')
				print self.fecha_hora, '           ',est,'         ',self.cc,' / 2000'
				self.datos 			= str(map(lambda x: round(self.df.fillna(-9999).loc[self.fecha_hora][x],1), self.df.columns.values)).strip('[]')
				self.calidad 		= str(map(lambda x: 1.0 if round(self.df.fillna(-9999).loc[self.fecha_hora][x],1) != -9999.0 else -9999.0, self.df.columns.values)).strip('[]')

				self.query = "INSERT INTO redAireDataRuido (codigoSerial, nombreCorto, fecha_hora, %s, %s) VALUES (%d, '%s', '%s', %s ,%s )" %(self.cols,self.cols_calidad,self.codigoSerial,est,self.fecha_hora,self.datos,self.calidad)
				print self.query
				self.conn_db 	= MySQLdb.connect (self.host, self.user, self.passwd, self.dbname)
				self.db_cursor 	= self.conn_db.cursor ()

        #                        self.db_cursor.execute (self.query)
         #                       self.conn_db.commit()
          #                      print 'execute'
           #                     self.conn_db.close ()

				try:
					self.db_cursor.execute (self.query)
					self.conn_db.commit()
					print 'execute'
					self.conn_db.close ()
					print '----------'
					self.conn_db.close ()
					pass
				except:
					pass
	def Insert_Into_Meteo(self,*args,**kwargs):

		self.Aire.Fechai	= kwargs.get('Fechai','2015-10-01 09:00')
		self.Aire.Fechaf	= kwargs.get('Fechaf',dt.datetime.now().strftime('%Y-%m-%d 00:00'))

		self.cc	= 0 # Contador para detener la insercion cuando son demasiados datos
		for est in self.EstR[self.EstR['Ruido']==1]['Nombre'].values: # nombre de las estaciones que miden ruido

			if est in ["MED-PJIC","GIR-SOSN"]: # Estaciones que no tiene Meteo propia
				continue

			if self.cc >= 10**5: break

			self.codigoSerial 	= self.EstR[self.EstR['Nombre']==est].index.values[0] #codigo de la estacion. ¿HAce excepcion pa la estaciones sin meteo?
			self.Read_Noise_txt(estacion=est,Ruido=False,Meteorologia=True) # Leer datos de meteo de la estacion ¿desde cuando?

			self.df 	= self.Met[est][self.Fechai:self.Fechaf] # Tomar los datos entre las fechas de interes
			self.df.dropna(how='all',inplace=True) 
			self.fechas 	= self.df.index # Si debia quitar el tru de consultar la base de datos de ruido como está en Ruido.py

			print '######################################################'
			print '-------------------%s---------------------------' %est

        		self.cols 			= 'dato_velocidad_viento' #str(map(lambda x: self.frec_ruido[x],self.df.columns.values)).strip('[]').replace("'","")
			self.cols_calidad 	    = 'calidad_dato_velocidad_viento' #str(map(lambda x: 'calidad_%s' %self.frec_ruido[x],self.df.columns.values)).strip('[]').replace("'","")
			self.df 	= self.df.reindex(self.fechas)
#			self.L 				= []
			self.host	= "192.168.1.74"
			self.user	= "siataRedAire_M"
			self.passwd	= "M0d_CalidadA1r3"
			self.dbname	= "siataRedAire"

			for i in range(self.fechas.size):
				if self.cc >= 10**5: break
				self.cc				+= 1
				self.fecha_hora 	= self.fechas[i].strftime('%Y-%m-%d %H:%M:%S')
				print self.fecha_hora, '           ',est,'         ',self.cc,' / 20000'
                
				self.datos 		= str(round(self.df[self.fechas[i]],1)) #str(map(lambda x: round(self.df.fillna(-9999).loc[self.fecha_hora][x],1))) #, self.df.columns.values)) #.strip('[]')
				self.calidad 		= str(1.0 if round(self.df.fillna(-9999)[self.fechas[i]],1) != -9999.0 else -9999.0) #, self.df.columns.values)) #.strip('[]')

				self.query = "INSERT INTO redAireDataRuidoMeteorologia (codigoSerial, nombreCorto, fecha_hora, %s, %s) VALUES (%d, '%s', '%s', %s ,%s )" %(self.cols,self.cols_calidad,self.codigoSerial,est,self.fecha_hora,self.datos,self.calidad)
				print self.query
				self.conn_db 	= MySQLdb.connect (self.host, self.user, self.passwd, self.dbname)
				self.db_cursor 	= self.conn_db.cursor ()

				try:
					self.db_cursor.execute (self.query)
					self.conn_db.commit()
					print 'execute'
					self.conn_db.close ()

				except:
					self.conn_db.close ()
					pass



        def Insert_Into_RuidoHorario(self,*args,**kwargs):

            Ruta='/home/calidadaire/ModuloRuido/'
#            self.LRAeqH= pd.read_pickle(Ruta+'LRAeqH.pkl') # Esta parte hay que automarizarla...

            self.Fechai     = kwargs.get('Fechai',self.Fechai)
            self.Fechaf     = kwargs.get('Fechaf',self.Fechaf)
    #               Fechaf     = kwargs.get('Fechaf',dt.datetime.now().strftime('%Y-%m-%d 00:00'))

            for est in self.EstR[self.EstR['Ruido']==1]['Nombre'].values: # nombre de las estaciones ACTUALES  que miden ruido
#            for est in np.array(['BEL-ALCA','MED-UNFM']): # Estaciones OFF


                    self.df         = self.LRAeqH[est][self.Fechai:self.Fechaf] # Tomar los datos entre las fechas de interes

		    # dos lineas para reemplazar el if de abajo
                    self.fechas = self.df.index
                    self.df = self.df.reindex(self.fechas, fill_value=-9999).replace(np.nan, -9999)

#                   self.df.dropna(how='all',inplace=True) 
#		    if self.df.size>0:
#			    self.fechas   = pd.date_range(self.df.index[0],self.df.index[-1],freq='H')
#       	            self.df  = self.df.reindex(self.fechas, fill_value=-9999)
#		    else:
#			   self.fechas=self.df.index


                    print '######################################################'
                    print '-------------------%s---------------------------' %est
                    self.codigoSerial       = self.EstR[self.EstR['Nombre']==est].index.values[0] #codigo de la estacion. ¿HAce excepcion pa la estaciones sin meteo?
                    self.cols               = 'LRAeqH' #['LRAeqD','LRAeqN','LRAeqDN'] #str(map(lambda x: frec_ruido[x],df.columns.values)).strip('[]').replace("'","")
                    self.cols_calidad      = 'calidad_LRAeqH' #['calidad_LRAeqD','calidad_LRAeqDN','calidad_LRAeqDN']
    #               self.df         = self.df.reindex(self.fechas)
    #                       L                          = []
                    self.host                       = "192.168.1.74"
                    self.user                       = "siataRedAire_M"
                    self.passwd                     = "M0d_CalidadA1r3"
                    self.dbname                     = "siataRedAire" 

                    for i in range(self.fechas.size):
    #                               if cc > 1999: break
    #                               cc                         += 1
                            self.fecha_hora   = self.fechas[i].strftime('%Y-%m-%d %H:%M:%S')
                            self.hora         = self.fechas[i].strftime('%H:%M:%S')
                            self.fecha        = self.fechas[i].strftime('%Y-%m-%d')
    #                               print fecha_hora, '           ',est,'         ',cc,' / 2000'
                            self.fechaUltimaModificacion = dt.datetime.now ().strftime ("%Y-%m-%d %H:%M:%S")
    
                            self.datos              = str(round(self.df[self.fechas[i]],1)) #str(map(lambda x: round(df.fillna(-9999).loc[fecha_hora][x],1))) #, df.columns.values)) #.strip('[]')
                            self.datos_act          =[self.cols+'='+str(round(self.df[self.fechas[i]],1))]
                            self.datos_act_str = ",".join (self.datos_act)
			    self.calidad = str(self.FlagH[est].loc[self.fechas[i]])
#                            self.calidad            = str(1.0 if round(self.df.fillna(-9999)[self.fechas[i]],1) != -9999.0 else -9999.0) #, df.columns.values)) #.strip('[]')
    
    #                       query = "INSERT INTO redAireDataRuidoHorario (" + '"' + "nombreCorto" + '"' + ", " + '"' + "codigoSerial" + '"' + ", fecha_hora, fecha, hora, %s, %s) VALUES ('%s','%d', '%s', '%s', '%s', %s ,%s )" %(cols,cols_calidad,est,codigoSerial,fecha_hora,fecha,hor$
    #                       query = 'INSERT INTO "redAireDataRuidoHorario" ("nombreCorto", "codigoSerial", fecha_hora, fecha, hora, {0}, {1}) VALUES ' + "('{2}','{3}', '{4}', '{5}', '{6}', {7} ,{8} )"
                            self.query = "INSERT INTO redAireDataRuidoHorario (nombreCorto, codigoSerial, fecha_hora, fecha, hora, %s, %s) VALUES ('%s','%d', '%s', '%s', '%s', %s ,%s )" %(self.cols,self.cols_calidad,est,self.codigoSerial,self.fecha_hora,self.fecha,self.hora,self.datos,self.calidad)                        
                            self.query_actualizacion= "UPDATE redAireDataRuidoHorario SET fecha_hora = '{0}', fecha = '{1}', hora = '{2}', codigoSerial = {3}, {7} = '{4}', fechaUltimaModificacion = '{5}', {6} WHERE fecha_hora = '{0}' AND fecha = '{1}' AND hora = '{2}' AND codigoSerial = {3}"
                            self.query_actualizacion = self.query_actualizacion.format (self.fecha_hora,self.fecha,self.hora,self.codigoSerial,self.calidad,self.fechaUltimaModificacion,self.datos_act_str,self.cols_calidad,self.cols)
    
    
                            self.conn_db    = MySQLdb.connect (self.host, self.user, self.passwd, self.dbname)
                            self.db_cursor  = self.conn_db.cursor ()
    
                            try:
                                    self.db_cursor.execute (self.query)
			            self.conn_db.commit()                   
			            self.conn_db.close ()
                                    print self.query
    
                            except MySQLdb.IntegrityError as int_err:
				    print int_err[0]

#   				    pass                 
                                # Si la insercion fallo por error de integridad 1062 (clave duplicada) se actualizan los datos, en caso contrario (fallo por causa desconocida) se propaga la excepcion
 	                            if int_err[0] == 1062:
        	                           self.db_cursor.execute (self.query_actualizacion)
				           self.conn_db.commit()                   
				           self.conn_db.close ()
                	                   print self.query_actualizacion
    				    pass

        def Insert_Into_RuidoDiario(self,*args,**kwargs):

            self.LRdiarios=['LRAeqD','LRAeqN','LRAeqDN']
#	    self.Flagdiarios=['FlagD','FlagN','FlagDN']

            self.Fechai     = kwargs.get('Fechai',self.Fechai)
            self.Fechaf     = kwargs.get('Fechaf',self.Fechaf)

            Ruta='/home/calidadaire/ModuloRuido/'

#            self.LRdf={}
#            for LRA in self.LRdiarios:
#                self.LRdf[LRA]=pd.read_pickle(Ruta+LRA+'.pkl')

	# Cambiar nan por -9999 para que incluya 
#	    self.LRAeqD.replace(np.nan, -9999.0, inplace=True)
#	    self.LRAeqN.replace(np.nan, -9999.0, inplace=True)
#	    self.LRAeqDN.replace(np.nan, -9999.0, inplace=True)

	    self.LRdf={self.LRdiarios[0]:self.LRAeqD, self.LRdiarios[1]:self.LRAeqN,self.LRdiarios[2]:self.LRAeqDN}

            for est in self.EstR[self.EstR['Ruido']==1]['Nombre'].values: # nombre de las estaciones ACTUALES  que miden ruido
#            for est in np.array(['BEL-ALCA','MED-UNFM']): # Estaciones OFF

		    self.dflags={'LRAeqD':self.FlagD[est], 'LRAeqN':self.FlagN[est],'LRAeqDN':self.FlagDN[est]}
                    self.dfi={}
                    for LRAi in self.LRdiarios:
                        self.dfi[LRAi]  = self.LRdf[LRAi][est][self.Fechai:self.Fechaf] # Tomar los datos entre las fechas de interes
			# Nuevas dos lineas para remplazar el if que está comendato debajo
			self.fechas = self.dfi[LRAi].index
			self.dfi[LRAi]  = self.dfi[LRAi].reindex(self.fechas, fill_value=-9999).replace(np.nan, -9999)
#                        self.dfi[LRAi].dropna(how='all',inplace=True)
#			if self.dfi[LRAi].size>0:
#	                        self.fechas     = pd.date_range(self.dfi[LRAi].index[0],self.dfi[LRAi].index[-1],freq='D')
#       		                self.dfi[LRAi]  = self.dfi[LRAi].reindex(self.fechas, fill_value=-9999)
#			else:
#				self.fechas = self.dfi[LRAi].index




                    print '######################################################'
                    print '-------------------%s---------------------------' %est
                    self.codigoSerial       = self.EstR[self.EstR['Nombre']==est].index.values[0] #codigo de la estacion. ¿HAce excepcion pa la estaciones sin meteo?

                    self.cols                = str(self.LRdiarios).strip('[]').replace("'","") #str(map(lambda x: self.frec_ruido[x],self.df.columns.values)).strip('[]').replace("'","")
                    self.cols_calidad        = str(map(lambda x:'calidad_'+x ,self.LRdiarios)).strip('[]').replace("'","") 

                    self.host                       = "192.168.1.74"
                    self.user                       = "siataRedAire_M"
                    self.passwd                     = "M0d_CalidadA1r3"
                    self.dbname                     = "siataRedAire" 

                    for i in range(self.fechas.size):

                            self.fecha_hora   = self.fechas[i].strftime('%Y-%m-%d %H:%M:%S')
                            self.hora         = self.fechas[i].strftime('%H:%M:%S')
                            self.fecha        = self.fechas[i].strftime('%Y-%m-%d')
                            self.fechaUltimaModificacion = dt.datetime.now ().strftime ("%Y-%m-%d %H:%M:%S")

                            self.datos        = str(map(lambda x:round(self.dfi[x][self.fechas[i]],1),self.LRdiarios)).strip('[]')
                            self.datos_act    = map(lambda x: str([x+'='+str(round(self.dfi[x][self.fechas[i]],1))]).strip('[]').replace("'",""),self.LRdiarios)
                            self.datos_act_str = ", ".join (self.datos_act)


                            self.calidad      = str(map(lambda x: self.dflags[x][self.fechas[i]],self.LRdiarios)).strip('[]')
#                            self.calidad_old  = str(map(lambda x: 1.0 if round(self.dfi[x].fillna(-9999)[self.fechas[i]],1) != -9999.0 else -9999.0,self.LRdiarios)).strip('[]')
			    self.calidad_act  =     map(lambda x: str(['calidad_'+x+'='+str(self.dflags[x][self.fechas[i]])]).strip('[]').replace("'c","c").replace("=","='"),self.LRdiarios)
#                            self.calidad_act_old  = map(lambda x: str(['calidad_'+x+'='+str(1.0 if round(self.dfi[x].fillna(-9999)[self.fechas[i]],1) != -9999.0 else -9999.0)]).strip('[]').replace("'c","c").replace("=","='"),self.LRdiarios)
                            self.calidad_act_str = ", ".join (self.calidad_act)


                            self.query = "INSERT INTO redAireDataRuidoDiario (nombreCorto, codigoSerial, fecha_hora, fecha, hora, %s, %s) VALUES ('%s','%d', '%s', '%s', '%s', %s ,%s )" %(self.cols,self.cols_calidad,est,self.codigoSerial,self.fecha_hora,self.fecha,self.hora,self.datos,self.calidad)
                            self.query_actualizacion= "UPDATE redAireDataRuidoDiario SET fecha_hora = '{0}', fecha = '{1}', hora = '{2}', codigoSerial = {3}, {4}, fechaUltimaModificacion = '{5}', {6} WHERE fecha_hora = '{0}' AND fecha = '{1}' AND hora = '{2}' AND codigoSerial = {3}"
                            self.query_actualizacion = self.query_actualizacion.format (self.fecha_hora,self.fecha,self.hora,self.codigoSerial,self.calidad_act_str,self.fechaUltimaModificacion,self.datos_act_str,self.cols_calidad)

                            self.conn_db    = MySQLdb.connect (self.host, self.user, self.passwd, self.dbname)
                            self.db_cursor  = self.conn_db.cursor ()
    
                            try:
                                    self.db_cursor.execute (self.query)
                                    self.conn_db.commit()
                                    self.conn_db.close ()
                                    print self.query
    
                            except MySQLdb.IntegrityError as int_err:
    
                                # Si la insercion fallo por error de integridad 1062 (clave duplicada) se actualizan los datos, en caso contrario (fallo por causa desconocida) se propaga la excepcion
                                    if int_err[0] == 1062:
                                           self.db_cursor.execute (self.query_actualizacion)
                                           self.conn_db.commit()
                                           self.conn_db.close ()
                                           print self.query_actualizacion
                                    pass



	def Plot_ImshowDN(self,*args,**kwargs):
		df			= kwargs.get('df',None)
		read			= kwargs.get('read',False)
		Diurno			= kwargs.get('Diurno',False)
		Nocturno		= kwargs.get('Nocturno',False)
		Indicador		= kwargs.get('Indicador',None)
		textsave		= kwargs.get('textsave','')


                estaciones = df.columns.values
		textizq=-6
		fontsize=26
		df=df.reindex( pd.date_range(self.Fechai,self.Fechaf,freq='D').date)
		#ticksdate = pd.date_range(self.Fechai,self.Fechaf).date
		ticksdate = pd.date_range(df.index[0],df.index[-1]).date
		df.index=pd.to_datetime(df.index)
		#estaciones = self.L.columns.levels[0].values[ np.unique(self.L.columns.labels[0].values())]

		plt.close('all')
		fig = plt.figure(figsize=((6+ticksdate.size)*1, 1*(4+df.columns.size)),facecolor='w',edgecolor='w')

		plt.subplots_adjust(wspace=.1,hspace=.3,bottom=0.05,left=-0.2,right=1.15,top=1.2)
		plt.rcParams["xtick.labelsize"]=fontsize
		plt.rcParams["ytick.labelsize"]=fontsize
		plt.rcParams["axes.labelsize"]=fontsize

		ax={}
		ax[1] = fig.add_axes((0.180,0.12,0.73,0.04))
		i=0
		ax[i]= fig.add_subplot(111)
		plt.setp(ax[i].spines.values(), color=(0.45, 0.45, 0.45))
		ax[i].tick_params( which=u'both',top='off',bottom='off',left='off',right='off', colors=(0.45, 0.45, 0.45))
		ax[i].xaxis.label.set_color((0.45, 0.45, 0.45))
		ax[i].yaxis.label.set_color((0.45, 0.45, 0.45))
		ax[i].spines['top'].set_visible(False)
		ax[i].spines['right'].set_visible(False)
		ax[i].spines['left'].set_visible(False)
		ax[i].spines['bottom'].set_visible(False)
		#contorno
		if Indicador!=None:
			name_Ind={'NCR':'Nivel de Contaminación por ruido','NExpo':'Nivel de exposición sonora','CS':'Factor de clima sonoro','DiffDN':'Diferencia Diurno Nocturno','NRT':'Índice de ruido de tráfico'}
			lim_Ind={'NCR':[70,150,10],'NExpo':[70,110,5],'CS':[0,45,5],'DiffDN':[-16,24,4],'NRT':[45,180,15]}
			if Indicador=='DiffDN':
				#cmap   = mpl.colors.ListedColormap(['W',[222/255.,41/255.,35/255.],[245/255.,81/255.,57/255.],[251/255.,109/255.,76/255.],[251/255.,132/255.,98/255.],[252/255.,173/255.,145/255.],[255/255.,235/255.,205/255.],[255/255.,211/255.,155/255.],[226/255.,185/255.,128/255.],[174/255.,140/255.,111/255.],[111/255.,84/255.,56/255.]])
				cmap   = mpl.colors.ListedColormap(['W',[31/255.,147/255.,192/255.],[48/255.,165/255.,193/255.],[73/255.,184/255.,193/255.],[112/255.,198/255.,188/255.],[150/255.,213/255.,183/255.],[254/255.,245/255.,186/255.],[254/255.,232/255.,158/255.],[254/255.,210/255.,111/255.],[254/255.,202/255.,93/255.],[254/255.,186/255.,70/255.]])
			else:
				cmap   = mpl.colors.ListedColormap(['w',[255/255.,235/255.,205/255.],[255/255.,211/255.,155/255.],[238/255.,197/255.,145/255.],[226/255.,185/255.,128/255.],[205/255.,170/255.,125/255.],[174/255.,140/255.,111/255.],[139/255.,115/255.,85/255.],[111/255.,84/255.,56/255.],[97/255.,68/255.,58/255.]])
			bounds=([-11] if Indicador=='CS' else [-11,0] if Indicador!='DiffDN' else [-99,-40])+np.arange(lim_Ind[Indicador][0],lim_Ind[Indicador][1],lim_Ind[Indicador][2]).tolist()
			bounds_ticks = bounds
			tickscolorbar=copy.deepcopy(bounds)
			tickscolorbar[0]='NAN'
			if Indicador=='DiffDN': tickscolorbar[1]=''
			tickscolorbar[-1]=''
		else:
			cmap   = mpl.colors.ListedColormap(['w',[0.69,0.87,0.93],[0.60,0.80,0.90],[0.32,0.71,0.77],[0.21,0.60,0.65],[0.156,0.50,0.58],[0.07,0.486,0.556],[0.01,0.35,0.40],[0.007,0.32,0.36],[0.0078,0.227,0.26],[0.0078,0.097,0.13]])
			bounds       = [-11,0,55,60,65,70,75,80,85,90,95,100,105]
			bounds_ticks = [-11,0,55,60,65,70,75,80,85,90,95,100,105]
			tickscolorbar  = ['NaN',0,55,60,65,70,75,80,85,90,95,100,105]
		norm = mpl.colors.BoundaryNorm(bounds, cmap.N)

		#cb2  = mpl.colorbar.ColorbarBase(ax[1], cmap=cmap, norm=norm,boundaries=bounds,ticks=bounds,spacing='proportional',orientation='horizontal')
		cb2  = mpl.colorbar.ColorbarBase(ax[1], cmap=cmap, norm=norm,boundaries=bounds,ticks=bounds,spacing='uniform',orientation='horizontal')
		cb2.set_ticks(bounds_ticks)
		self.bounds=bounds
		cb2.set_ticklabels(tickscolorbar if Indicador!='DiffDN' else ['NAN','']+np.abs(bounds[2:]).tolist())
		cb2.ax.tick_params(labelsize=fontsize)
		#ax[1].set_xlabel(self.labelx[var],fontproperties=prop_1,fontsize=fontsize2)
		ax[1].set_xlabel('Nivel de Presión Sonora dB(A)' if Indicador!='DiffDN' else '\n        Nivel de Presión Sonora dB(A)',fontproperties=prop_1,fontsize=fontsize+6, color = 'k')
		if Indicador=='DiffDN':
			ax[0].text(6.5,-2.3,'LRA$_{eq,n}$ > LRA$_{eq,d}$',fontproperties=prop_1,fontsize=fontsize+5, color = 'k')
			ax[0].text(20.5,-2.3,'LRA$_{eq,n}$ < LRA$_{eq,d}$',fontproperties=prop_1,fontsize=fontsize+5, color = 'k')
		#norm1=mpl.colors.Normalize(self.limC[self.resol][var][0]-self.limC[self.resol][var][1]/7. ,self.limC[self.resol][var][1])




		contf = ax[0].imshow(df[estaciones].fillna(-10 if Indicador!='DiffDN' else -99).T.values,interpolation='nearest',cmap=cmap, aspect='equal', origin='lower',
			extent=[0,ticksdate.size,0,df.columns.size],norm=norm)


		#Valores numericos
		for i in range(df.columns.size):
			#ax[0].text(textizq,i+0.75,'%s' %'' if estaciones[i] =='vacia1' or estaciones[i] =='vacia2' or estaciones[i] =='vacia' else estaciones[i][:],ha='left',va='center',fontsize=fontsize,fontproperties=prop_1)
			ax[0].text(textizq,i+0.25,self.EstR[self.EstR['Nombre'].isin([estaciones[i]])]['Nombre_Estacion'].values[0],ha='left',va='center',fontsize=fontsize+4,fontproperties=prop)
			ax[0].axhline(i,color='w',lw=1)


		ax[0].axhline(len(estaciones)+1,xmin=np.abs(textizq-10)/float(ticksdate.size+10+np.abs(textizq-10)), xmax=float(ticksdate.size+np.abs(textizq-10))/(ticksdate.size+10+np.abs(textizq-10)),color='k',lw=2.5)
		ax[0].text(textizq,df.columns.size+.6,u'Estaciones',ha='left',va='center',fontsize=fontsize+6,fontproperties=prop_2)


		ax[0].set_ylim(-.5,len(estaciones)+3.5)
		ax[0].set_xlim(textizq-10,ticksdate.size+10)
		ax[0].set_xticklabels('')
		ax[0].set_yticklabels('')

		ax[0].axvline(x=ticksdate[-1].day,ymin= 1./(len(estaciones)+13.0),ymax=(len(estaciones)+.5)/(len(estaciones)+4.),color='gray',lw=1) #ymin= 1./(len(estaciones)+4.)
		ax[0].axhline(df.columns.size,xmin=np.abs(textizq-10)/float(ticksdate.size+10+np.abs(textizq-10)), xmax=float(ticksdate.size+np.abs(textizq-10))/(ticksdate.size+10+np.abs(textizq-10)),color='gray',lw=1)

		#Valores numericos
		for i in range(df.columns.size):
		    print i
		    #for j in range(ticksdate.size):
		    for j, k in zip(range(ticksdate.size), ticksdate):
			    dato = df[estaciones[i]][df.index.date==k].values[0]
			    #dato = np.na
			    dato = dato if np.isnan(dato) else np.float(int(dato))
			    norm= 1 if Diurno else 2 if Nocturno else 5
			    colorvalor='w' if Diurno==False and Nocturno==False and Indicador==None else 'k' if Indicador!=None else 'w' if dato>self.norma_ruido[estaciones[i]][norm] else 'k'
			    valorletra='' if np.isnan(dato) else '%.f' %dato if Diurno==False and Nocturno==False and Indicador!='DiffDN' else '%.f' %np.abs(dato) if Indicador=='DiffDN' else u'%.f*' %dato if dato>self.norma_ruido[estaciones[i]][norm] else '%.f' %dato
			    ax[0].text(j+0.5,i+0.5,valorletra, ha='center',va='center', fontsize=fontsize, color= colorvalor) #, fontproperties=prop_1)
			    #ax[0].text(j+0.5,i+0.5, '' if np.isnan(dato) else '%.f' %dato, ha='center',va='center', fontsize=fontsize, color= colorvalor) #, fontproperties=prop_1)
		    ax[0].axhline(i,xmin=np.abs(textizq-10)/float(ticksdate.size+10+np.abs(textizq-10)), xmax=float(ticksdate.size+np.abs(textizq-10))/(ticksdate.size+10+np.abs(textizq-10)),color='gray',lw=1)


		pos1 = 2
		for j in range(ticksdate.size):
		    ax[0].text(j+0.5,df.columns.size+pos1-0.5,'%s%d' %(self.dias_es[ticksdate[j].strftime('%w')],ticksdate[j].day),fontsize=fontsize+2,ha='center',va='center',fontproperties=prop_1)
		    ax[0].axvline(x=j,ymin=0.05,ymax=(len(estaciones)+.5)/(len(estaciones)+4.),color='gray',lw=1)
		    if ((j==0) & (ticksdate[1].day!=1)) | (ticksdate[j].day ==1) : ax[0].text(j+.1, df.columns.size+pos1+0.1,'%s del %d' %(self.mes_es[ticksdate[j].month],ticksdate[j].year)+('' if Indicador==None else ' - '+name_Ind[Indicador]+' '+textsave),ha='left',va='bottom',fontsize=fontsize+4)

		if len(textsave)>0:
			plt.savefig('/home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_%s_%s.pdf'%('D' if Diurno else 'N' if Nocturno else Indicador if Indicador!=None else 'DN',textsave),bbox_inches='tight')  
		else:
			plt.savefig('/home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_%s.pdf'%('D' if Diurno else 'N' if Nocturno else Indicador if Indicador!=None else 'DN'),bbox_inches='tight')  

		if kwargs.get('Procuraduria',False):
			os.system('scp /home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_DN.pdf calidadaire@192.168.1.10:/home/calidadaire/Informe_Procuraduria/Figuras/RuidoAmb/Ruido_DN.pdf')
		else:
			os.system('scp /home/calidadaire/ModuloRuido/Informe/Figuras/Ruido/Ruido_%s.pdf nroldan@192.168.1.74:/var/www/CalidadAire/Figuras/Ruido/Historico/Ruido_%s_%s%s.pdf'%('D' if Diurno else 'N' if Nocturno else 'DN','D' if Diurno else 'N' if Nocturno else 'DN',self.mes_es[int(self.Fechaf[5:7])],self.Fechaf[0:4]))


	def Plot_Excedencias(self,*args,**kwargs):
                Data                    = kwargs.get('df',None)
                if Data==None:
                        Data=self.Aire.Aire_db(LRAdiario=True,Variable=['LRAeqD','LRAeqN','LRAeqDN'])

		nameruido={'ITA-ACUA':'Acuaparque Ditaires','GIR-SOSN':u'SOS Aburrá Norte','MED-PJIR':u'Politécnico JIC /Regional','MED-PJIC':u'Politécnico Colombiano\nJaime Isaza Cadavid','MED-PLMA':'Plaza Mayor','ITA-CODI':u'Complejo de Ditaires','SAB-SEMS':u'Secret. de Educación','GIR-BOTJ':u'Droguería Botica Junín','MED-SIAT':'Torre SIATA','CEN-TRAF':'Tráfico Centro','MED-ZOOL':'Zoologico Santa Fe','ITA-SAMA':'Barrio Santa María, Itagüí'}
		## Dataframe a gráficar
		DataNorm=pd.DataFrame(index=Data['LRAeqD'].columns,columns=['Diurna','Nocturna'])

		for est in Data['LRAeqD'].columns:
		    DataNoche=Data['LRAeqN'][est]
		    DataDia=Data['LRAeqD'][est]
		    DataNorm['Nocturna'][est]=DataNoche[DataNoche>self.norma_ruido[est][2]].count()*100./DataNoche.count()
		    DataNorm['Diurna'][est]=DataDia[DataDia>self.norma_ruido[est][1]].count()*100./DataDia.count()

		self.Datanorm=DataNorm
		plt.close('all')
		fig = plt.figure(2,figsize=(9, 6),facecolor='w',edgecolor='w')

		plt.subplots_adjust(wspace=.2,hspace=.35,bottom=0.2,left=0.1,right=0.9,top=0.8)
		plt.rcParams["ytick.labelsize"]=13
		plt.rcParams["xtick.labelsize"]=13
		plt.rcParams["xtick.color"]='gray'
		plt.rcParams["ytick.color"]='gray'

		ax={}
		ax[1] = fig.add_axes((0.55,0.225,0.28,0.70))



		ax[1].set_title(self.mes_es[int(self.Fechai[5:7])]+' del '+self.Fechai[0:4],color='gray',fontsize=14,loc='right')


		#Gráfica de barras
		ax[1].barh(np.arange(len(DataNorm))+0.2, DataNorm['Diurna'],0.4, align='center',color='turquoise', ecolor='black',label='Diurna')
		ax[1].barh(np.arange(len(DataNorm))-0.2, DataNorm['Nocturna'],0.4, align='center',color='teal', ecolor='black',label='Nocturna')


		ax[1].spines['top'].set_visible(False)
		ax[1].spines['right'].set_visible(False)
		ax[1].spines['left'].set_color((0.45, 0.45, 0.45))
		ax[1].spines['bottom'].set_color((0.45, 0.45, 0.45))
		ax[1].set_xlim(0,100)

		#Textos
		est=[]
		for f in range(0,len(self.Datanorm.index)):
		    ax[1].text(-84,(f-0.5 if DataNorm.index[f]!='MED-PJIC' else f-0.75),nameruido[DataNorm.index[f]],horizontalalignment='right',fontsize=11)
		    ax[1].text(-55,f-0.1,self.norma_ruido[DataNorm.index[f]][1],horizontalalignment='right',fontsize=13,color='turquoise')
		    ax[1].text(-20,f-0.1,self.norma_ruido[DataNorm.index[f]][2],horizontalalignment='right',fontsize=13,color='teal')
		    est.append(self.EstR['Municipio'][self.EstR['Nombre']==DataNorm.index[f]].values[0])
		ax[1].set_xlabel(u'Días en excedencia de la \nnorma [%]',fontsize=13)
		ax[1].text(-49,len(self.Datanorm.index)-.5,'Diurna',horizontalalignment='right',fontsize=13,color='turquoise')
		ax[1].text(-10,len(self.Datanorm.index)-.5,'Nocturna',horizontalalignment='right',fontsize=13,color='teal')
		ax[1].text(-59,len(self.Datanorm.index),'Norma (dB)',fontsize=13,fontproperties=prop)

		# nombre estaciones
		plt.yticks([0,1,2,3,4,5,6,7],est,position=(-0.8,0),fontproperties=prop,fontsize=14)

		#leyenda
		leg=ax[1].legend(bbox_to_anchor=(0.5,-0.18),loc='upper center',fontsize=13,ncol=2,frameon=False)
		leg.get_frame().set_edgecolor((0.45, 0.45, 0.45))

		if kwargs.get('Procuraduria',True):
			plt.savefig('/home/calidadaire/ModuloRuido/Figuras/Procuraduria/Ruidoimg.pdf')
			os.system("scp /home/calidadaire/ModuloRuido/Figuras/Procuraduria/Ruidoimg.pdf nroldan@192.168.1.74:/var/www/CalidadAire/Figuras/Ruido/Ruidoexd.pdf")
			os.system("scp /home/calidadaire/ModuloRuido/Figuras/Procuraduria/Ruidoimg.pdf calidadaire@192.168.1.10:/home/calidadaire/Informe_Procuraduria/Figuras/RuidoAmb/Ruidoexd.pdf")

	def Plot_Tabla(self,*args,**kwargs):
		Data			= kwargs.get('df',None)
		if Data==None:
	 		Data=self.Aire.Aire_db(LRAdiario=True,Variable=['LRAeqD','LRAeqN','LRAeqDN'])

		clust_data1=[]
		clust_data1.append(Data['LRAeqD'].count().values)
		clust_data1.append(Data['LRAeqD'].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN))).values)
		clust_data1.append(Data['LRAeqN'].count().values)
		clust_data1.append(Data['LRAeqN'].apply(lambda x: 10.*np.log10((10.**(x/10.)).sum()/ (x.count() if x.count()!= 0 else np.NaN))).values)


		for g in [1,3]: clust_data1[g]=map(lambda x: '%.2f'% x , clust_data1[g])
		plt.close('all')
		fig = plt.figure(2,figsize=(8,2),facecolor='w',edgecolor='w')

		plt.subplots_adjust(wspace=.2,hspace=.35,bottom=0.0,left=0.05,right=1.5,top=1.0)

		ax={}
		ax[1] = fig.add_axes((0.18,-2,0.8,5.0))

		# Hide axes
		ax[1].xaxis.set_visible(False) 
		ax[1].yaxis.set_visible(False)

		# Table from Ed Smith answercellLoc='right'
		collabel=(Data['LRAeqD'].columns.values)
		ax[1].table(cellText=clust_data1,colLabels=collabel,cellLoc='center',loc='center',fontsize=18,rowLabels=['CM,d','Media,d[dB(A)]','CM,n','Media,n[dB(A)]'],rowColours=['turquoise','turquoise','teal','teal'],colColours=np.repeat('lightgray',8),colWidths=np.repeat(0.13,8)) #bbox=(0,0,1.5,1.5)

		ax[1].axis('off')
		plt.savefig('/home/calidadaire/ModuloRuido/Figuras/Procuraduria/TablaRuido.pdf',)

		if kwargs.get('Procuraduria',True):
			os.system("scp /home/calidadaire/ModuloRuido/Figuras/Procuraduria/TablaRuido.pdf calidadaire@192.168.1.10:/home/calidadaire/Informe_Procuraduria/Figuras/RuidoAmb/")
			os.system("scp /home/calidadaire/ModuloRuido/Figuras/Procuraduria/TablaRuido.pdf nroldan@192.168.1.74:/var/www/CalidadAire/Figuras/Ruido")

	def Plot_Procuraduria(self,*args,**kwargs):
		LRs=self.Aire.Aire_db(LRAdiario=True,Variable=['LRAeqD','LRAeqN','LRAeqDN'])
		self.Plot_Tabla(df=LRs) ##Por algún motivo tenia [estaciones]
		self.Plot_ImshowDN(df=LRs['LRAeqDN'],Procuraduria=True)
		self.Plot_Excedencias(df=LRs)

	def Plot_CD(self,*args,**kwargs):
                df                   = kwargs.get('df',None)
		df[df<15] = np.nan
		limyi=50 if df.groupby(df.index.hour).quantile(0.25).min().min()>50 else 40
		limys=100 if df.groupby(df.index.hour).quantile(0.75).max().max()<100 else 110
		for estacion in df.columns:
			plt.close('all')
			fig = plt.figure(2,figsize=(8, 5),facecolor='w',edgecolor='w')
			plt.subplots_adjust(wspace=.2,hspace=.35,bottom=0.2,left=0.2,right=0.95,top=0.9)
			#plt.rcParams["ytick.labelsize"]=16
			plt.rcParams["xtick.color"]='gray'
			plt.rcParams["ytick.color"]='gray'
			ax=fig.add_subplot(111) 

			ax.set_title(estacion,fontsize=20, loc='right',color='gray',fontproperties=prop_2)
			ax.set_ylabel(r'Nivel de Presión Sonora Horaria dB(A)', fontsize=16,color='gray')


			#df=df['GIR-SOSN'].astype(float)
			df[estacion].groupby(df.index.hour).quantile(0.5).plot(ax=ax,label='Mediana')
			ax.fill_between(df[estacion].groupby(df.index.hour).mean().index,df[estacion].groupby(df.index.hour).quantile(0.25),df[estacion].groupby(df.index.hour).quantile(0.75),alpha=0.3,label='IQR')
			ax.set_xlabel(r'HORA', fontsize=18,color='gray')
			ax.set_xlim(0,23)
			ax.set_ylim(limyi,limys)

			ax.spines['top'].set_visible(False)
			ax.spines['right'].set_visible(False)
			ax.spines['left'].set_color((0.45, 0.45, 0.45))
			ax.spines['bottom'].set_color((0.45, 0.45, 0.45))

			#plt.legend()

			leg=plt.legend(bbox_to_anchor=(0.8,-0.15),loc='downer center',fontsize=16,ncol=2,frameon=False)
			leg.get_frame().set_edgecolor((0.45, 0.45, 0.45))
			plt.setp(leg.get_texts(), color='gray')


			plt.rcParams["ytick.labelsize"]=14
			plt.rcParams["xtick.labelsize"]=14
			plt.rcParams["xtick.color"]='gray'
			plt.rcParams["ytick.color"]='gray'

			if kwargs.get('Informe',False):
				plt.savefig('Informe/Figuras/CD_'+estacion+'.pdf')
				os.system('scp Informe/Figuras/CD_'+estacion+'.pdf nroldan@192.168.1.74:/var/www/CalidadAire/Figuras/Ruido')
			else:
				plt.savefig('Figuras/CD_'+estacion+'.pdf')
				os.system('scp Figuras/CD_'+estacion+'.pdf nroldan@192.168.1.74:/var/www/CalidadAire/Figuras/Ruido')


	def Plot_MapaEst(self,*args,**kwargs):

		self.figsize    = kwargs.get('figsize',11)
		self.estaciones = kwargs.get('estaciones', None)
		self.fontsize   = kwargs.get('fontsize',16)
		self.textsave   = kwargs.get('textsave',None)
		Ruido   = kwargs.get('Ruido',False)
		self.varsave    = 'PM25' if self.var =='PM2.5' else 'PM25M' if self.var =='PM2.5M' else 'Meteorologia' if self.var == 'P_SSR' else self.var
		self.path       = kwargs.get('path','nroldan@siata.gov.co:/var/www/CalidadAire/Figuras/')

		print self.estaciones
		plt.close('all')
		self.fig                = plt.figure(figsize=(self.figsize,self.figsize*(6.515-5.975)/(75.725-75.21)),facecolor='w',edgecolor='w')
		self.ax                 ={}
		self.ax[0]              = self.fig.add_axes((0.00,0.00,1,1))            #Relieve

		for i in self.ax.keys():
			plt.setp(self.ax[i].spines.values(), color=None) #(0.45, 0.45, 0.45))
			if i > 0: self.ax[i].tick_params(labelleft='off',labelbottom='off',right='off',left='off',bottom='off',top='off',which='both', colors=(0.45, 0.45, 0.45))

		self.m = Basemap(ax=self.ax[0],projection='merc',llcrnrlat=5.975,urcrnrlat=6.515,llcrnrlon=-75.725,urcrnrlon=-75.21,resolution='h') # area_thresh=1000$

		if Ruido: 
			self.m.readshapefile('/home/calidadaire/ModuloAire/Tools/AreaMetropolitana','Area',linewidth=0.0,color=(0.0078,0.227,0.26),zorder=4)
			patches   = []
			colorshapes=[[209./255.,209./255.,209./255.],[192./255.,192./255.,192./255.],[177./255.,177./255.,177./255.],[162./255.,162./255.,162./255.],[226./255.,226./255.,226./255.]]
			for shape in self.m.Area:
				patches.append( Polygon(np.array(shape), True) )
			self.ax[0].add_collection(PatchCollection(patches, facecolor=colorshapes, edgecolor=None, linewidths=0.0))

		if type(self.estaciones)==type(None):
			self.X,self.Y           = self.m(self.EstR[self.EstR[self.var]==1]['Longitud'].values,self.EstR[self.EstR[self.var]==1]['Latitud'].values)
			self.estaciones         = self.EstR[self.EstR[self.var]==1]['Nombre'].values
		else:
			self.x                  = self.EstR[self.EstR['Nombre'].isin( self.estaciones)].sort_values(by='Latitud',ascending=False)[['Latitud','Longitud']]
			self.X,self.Y   = self.m(self.x['Longitud'].values,self.x['Latitud'].values)
		self.esta               = self.EstR[self.EstR['Nombre'].isin(self.estaciones)]

		azulito = (214./255, 232./255 ,233./255)
		azuloscuro = (0.0078,0.227,0.26)
		self.m.scatter(self.X,self.Y,s=900 if Ruido==False else 1100 ,facecolor = azulito, edgecolor=azuloscuro,lw=1,alpha=1,zorder=5)


		# Numeros
		NumRuido={70:1,76:2,99:5,97:8,96:4,60:6,12:3,95:7} ##17:4, 6:7
		#NumRuido=dict(zip(self.EstR.loc[self.EstR.Ruido==1].index.values,range(1,len(self.EstR.loc[self.EstR.Ruido==1].index.values)+1)))
		self.zor,self.c = 10,0
		for i in range(len(self.X)):
			#self.ax[0].text(self.X[i],self.Y[i],'%.f' %self.esta.loc[self.esta.index[i],'Enumeracion'] if kwargs.get('Enumeracion',False) else NumRuido[self.esta.index[i]] if kwargs.get('Ruido',False) else self.esta.index[i], ha='center',va='center', fontsize=self.fontsize,color=azuloscuro,zorder=self.zor,fontproperties=prop_2,)
			self.ax[0].text(self.X[i],self.Y[i],'%.f'%NumRuido[self.esta.index[i]], ha='center',va='center', fontsize=self.fontsize,color=azuloscuro,zorder=self.zor,fontproperties=prop_2)
			self.zor+=1

		#Saving
		print 'Saving'
		if 'textsave' not in kwargs.keys():
			plt.savefig('/home/calidadaire/ModuloRuido/ReporteRuido/Figuras/%s/PuntosEstaciones_%s.pdf' %(self.varsave,self.varsave),bbox_inches='tight', transparent = True, format = "pdf")
			os.system('scp /home/calidadaire/ModuloRuido/ReporteRuido/Figuras/%s/PuntosEstaciones_%s.pdf %s%s' %(self.varsave,self.varsave,self.path,self.varsave))
		else:
			plt.savefig('/home/calidadaire/ModuloRuido/ReporteRuido/Figuras/PuntosEstaciones_%s.pdf' %(self.textsave),bbox_inches='tight',  transparent = True, format = "pdf")
			os.system('scp /home/calidadaire/ModuloRuido/ReporteRuido/Figuras/PuntosEstaciones_%s.pdf %s' %(self.textsave,self.path))
